#ifndef CACTION_H
#define CACTION_H

typedef enum {
    fixedCentral,
    firstFromNearest,
    secondFromNearest
} NODEITERSTYLE;

typedef enum { 
    newKey,
    addKey,
    newMessage,
    sendMessage,
    dispatchMessages,
    getSharedKeys,
    combineKeys2,
    combineKeys,
} ACTION_TYPE;

typedef enum {
    void_Ptr,
    SENSITIVE_OBJECT_Ptr,
    DATA_LIST_Ptr,
    SENSOR_NODE_Ptr
} PTR_TYPE;

typedef struct _PTR_TYPE_INDEX {
    PTR_TYPE    ptrType;
    int         ptrIndex;
} PTR_TYPE_INDEX;

class CAction {
public:
    virtual int TryAssignPointer(PTR_TYPE ptrType, int ptrIndex, void* pPtr) { return STAT_OK; }
    virtual int Execute() { return STAT_OK; }
    virtual int CheckPointerCorrectness() { return STAT_INVALID_PTR; } 
};


typedef list<CAction*>  lac;

#define MAX_NODES_IN_STRATEGY   5
typedef struct _SCRIPT_STRATEGY {
    int             numNodes;                               // number of involved nodes
    NODEITERSTYLE   nodeIterStyle[MAX_NODES_IN_STRATEGY];   // iteration style for given node
    DWORD           nodeRelations[MAX_NODES_IN_STRATEGY][MAX_NODES_IN_STRATEGY]; // required position relation between each two nodes
    
    lac             actionsList;
    int             ptrCount_SENSITIVE_OBJECT;      // number of used distinct pointers to SENSITIVE_OBJECT
    int             ptrCount_SENSOR_NODE;           // number of used distinct pointers to SENSOR_NODE
    
    void release() {
        lac::iterator   iter;
        CAction*        pAction;
        for (iter = actionsList.begin(); iter != actionsList.end(); iter++) {
            pAction = *iter;
            delete pAction; 
        }
    }

} SCRIPT_STRATEGY;

typedef list<SCRIPT_STRATEGY*> lss;
#endif