
#include "stdafx.h"
#include "CommonFnc.h"
#include <math.h>
#include "gdiplus\CaptureEx.h"

void CCommonFnc::BYTE_xor(unsigned char *x1, unsigned char *x2, int length) {
	for (int i=0;i<length;i++)
	x1[i]^=x2[i];
}


int CCommonFnc::Dir_Create(CString path) {
    int     status = STAT_OK;
    CString helpPath;    

    if (path.GetLength() > 0) {
        if (path.GetAt(path.GetLength() - 1) != '\\') path += "\\";

        helpPath = path;

        char* sHelpString = new char[helpPath.GetLength() + 1];
        strncpy_s(sHelpString, helpPath.GetLength() + 1, (LPCTSTR) helpPath, helpPath.GetLength() + 1);

        int i = 0;
        for (;;)
        {
            for (; (i < path.GetLength()) && (path.GetAt(i) != '\\'); i ++);

            if (i == path.GetLength())
            {
                break;
            }

            sHelpString[i] = 0;

            CreateDirectory(sHelpString, NULL);

            sHelpString[i] = '\\';

            i ++;
        }

        delete[] sHelpString;         
    }
      
    return status;
}

int CCommonFnc::Path_Normalize(CString* path) {
	int		status = STAT_OK;
	int		pos = -1;
	CString workPath = *path;
	CString	truncPath;
    BOOL    trunc = FALSE;

    if (workPath.GetLength() != 0) {
        trunc = FALSE;
        if (((pos = workPath.ReverseFind('\\')) == workPath.GetLength()-1) && (pos != -1)) {
            trunc = TRUE; 
        }
        else {
            if (((pos = workPath.ReverseFind('/')) == workPath.GetLength()-1) && (pos != -1)) trunc = TRUE;
        }
    
        while (trunc) {
		    //odebrani posledniho lomitka
		    truncPath = workPath.Left(pos);
		    workPath = truncPath;

            trunc = FALSE;
            if (((pos = workPath.ReverseFind('\\')) == workPath.GetLength()-1) && (pos != -1)) trunc = TRUE; 
            if (((pos = workPath.ReverseFind('/')) == workPath.GetLength()-1) && (pos != -1)) trunc = TRUE;
	    }
    }

	*path = workPath;

    return status;
} 

int CCommonFnc::Path_ExtractDirPath(CString filePath, CString* pDirPath) {
    int     status = STAT_OK;
    
    *pDirPath = filePath.Left(filePath.ReverseFind('\\'));
    Path_Normalize(pDirPath);

    return status;
}



int CCommonFnc::File_AppendString(CString filePath, CString data) {
    int             status = STAT_OK;
    CFile           file;

    if (file.Open(filePath, CFile::modeWrite | CFile::modeCreate | CFile::modeNoTruncate)) {
        file.SeekToEnd();
        file.Write((LPCTSTR) data, data.GetLength());
        file.Close();
    }
    else status = STAT_FILE_OPEN_FAIL;   

    return status;

}

int CCommonFnc::BYTE_ConvertFromHexStringToArray(CString hexaString, BYTE* pArray, BYTE* pbArrayLen) {
    int     status = STAT_OK;
    DWORD   arrayLen = *pbArrayLen;    
    
    status = BYTE_ConvertFromHexStringToArray(hexaString, pArray, &arrayLen);
    if (arrayLen > 0xFF) status = STAT_NOT_ENOUGHT_DATA_TYPE;
    else *pbArrayLen = (BYTE) arrayLen;

    return status;
}

int CCommonFnc::BYTE_ConvertFromHexStringToArray(CString hexaString, BYTE* pArray, DWORD* pbArrayLen) {
    int         status = STAT_OK;
    DWORD       pos = 0;
    DWORD       pos2 = 0;
    CString     hexNum;
    DWORD       num;
    BYTE*       pTempArray = NULL;
    DWORD       tempArrayPos = 0;

    // EAT SPACES
    hexaString.TrimLeft(); hexaString.TrimRight();
    hexaString += " ";
    hexaString.GetLength();

    if (status == STAT_OK) {
        pTempArray = new BYTE[hexaString.GetLength()];
        memset(pTempArray, 0, hexaString.GetLength());

        pos = pos2 = 0;
        while ((pos = hexaString.Find(' ', pos2)) != -1) {
            hexNum = hexaString.Mid(pos2, pos - pos2);
            hexNum.TrimLeft(); hexNum.TrimRight();
            if (hexNum.GetLength() > 0) {
                num = _tcstol((LPCTSTR) hexNum, NULL, 16);
        
                if (num == 0xFF) pTempArray[tempArrayPos] = 0xFF;
                else pTempArray[tempArrayPos] = (BYTE) num & 0xFF;
                
                tempArrayPos++;
            }
            pos2 = pos + 1;
        }

        if (tempArrayPos > *pbArrayLen) {
            status = STAT_NOT_ENOUGHT_MEMORY;
        }  
        else {
            memcpy(pArray, pTempArray, tempArrayPos);
        }
        *pbArrayLen = tempArrayPos;

        if (pTempArray) delete[] pTempArray;
    }

    return status;
}

int CCommonFnc::BYTE_ConvertFromArrayToHexString(BYTE* pArray, DWORD pbArrayLen, CString* pHexaString) {
    int         status = STAT_OK;
    CString     hexNum;
    DWORD       i;

    *pHexaString = "";
    for (i = 0; i < pbArrayLen; i++) {
        hexNum.Format("%.2x", pArray[i]);
        hexNum += " ";

        *pHexaString += hexNum;
    }

    pHexaString->TrimRight(" ");

    return status;
}

int CCommonFnc::File_GetIniSections(CString filePath, lcs* pSectionsList) {
    int     status = STAT_OK;
    CFile   file;
    char*   pBuffer = NULL;
    DWORD   cBuffer = 0;
    DWORD   cReaded = 0;

    // OBTAIN FILE SIZE == MAXIMUM VALUE LENGTH
    if (file.Open(filePath, CFile::modeRead)) {
        cBuffer = (DWORD) file.GetLength();
        file.Close();
    }
    else status = STAT_FILE_OPEN_FAIL;

    if (status == STAT_OK) {
        pBuffer = new char[cBuffer];
        memset(pBuffer, 0, cBuffer);

        // OBTAIN SECTION NAMES
        if ((cReaded = GetPrivateProfileString(NULL, NULL, "", pBuffer, cBuffer, (LPCTSTR) filePath)) != 0) {
            if (cReaded < 100000000) {
                // PARSE SECTION NAMES
                if ((status = CCommonFnc::String_ParseNullSeparatedArray((BYTE*) pBuffer, cReaded, pSectionsList)) == STAT_OK) {
                } 
            }
        }

        if (pBuffer) delete[] pBuffer;
    }
    
    return status;
}

int CCommonFnc::String_ParseNullSeparatedArray(BYTE* array, DWORD arraySize, lcs* pValueString) {
    int     status = STAT_OK;
    DWORD   pos;
    CString itemName;

	pos = 0;
	itemName = "";
	
	if (arraySize > 0) {
		while (pos <= (arraySize-1)) {	// -1 belong to special end zero
			if (array[pos] == '\0') {	// end of one item
				if (itemName != "") pValueString->push_back(itemName);

				itemName = "";
			} 
			else itemName += array[pos];

			pos++;

		}	//end while
	}

    return status;
}

int CCommonFnc::String_ParseSeparatedArray(CString parseString, CString separator, lcs* pSeparatedList) {
	int		status = STAT_OK;
	CString	value;
	int		pos = 0;
	int		pos2 = 0;

	parseString += separator;

    while ((pos2 = parseString.Find(separator, pos)) != -1) {
        value = parseString.Mid(pos, pos2 - pos);
        if (value != "") {
			pSeparatedList->push_back(value);
		}
                
        pos = pos2 + separator.GetLength();
	}
	
	return status;
}

int CCommonFnc::Graph_WM_CREATE(GRAPH_DATA* pGlobalData, HWND hWnd, SCROLLINFO* pSi) {
    int     status = STAT_OK;
	RECT            r;

    if (pSi != NULL) {
	    GetClientRect(hWnd,&r);			
	    ZeroMemory(pSi, sizeof(SCROLLINFO));
	    pSi->cbSize=sizeof(SCROLLINFO);
	    pSi->fMask=SIF_ALL|SIF_DISABLENOSCROLL;
	    pSi->nMin=1;
	    pSi->nMax=10000;
	    pSi->nPage=r.right;
	    pSi->nPos=1;
	    SetScrollInfo(hWnd,SB_HORZ,pSi,TRUE);
	}
	else {
	    SCROLLINFO si;
	    GetClientRect(hWnd,&r);			
	    ZeroMemory(&si, sizeof(SCROLLINFO));
	    si.cbSize=sizeof(SCROLLINFO);
	    si.fMask=SIF_ALL;
	    si.nMin=1;
	    si.nMax=10000;
	    si.nPage=r.right;
	    si.nPos=1;
	    SetScrollInfo(hWnd,SB_HORZ,&si,TRUE);
	}
	 
	pGlobalData->global_horizontal=0;		
	InvalidateRect(hWnd,NULL,TRUE);
    
    return status;
}

int CCommonFnc::Graph_Plot(GRAPH_DATA* pGlobalData, HWND hWnd, SCROLLINFO* pSi) { 
    int             status = STAT_OK;
/*
	float           help;
	float           y1;
    float           y2;
	int             x1;
    int             x2;
    int             incrStep;
    int             i;
    int             maxLength = 0;
	int             global_horizontal;
    Pen*            pActPen;
/**/    
	RECT            r;
	HDC             hdc;
	PAINTSTRUCT     ps;

	// TODO: add test for painting and fill with required graphic
	if (FALSE) {
	    hdc = BeginPaint(hWnd, &ps);
        GetClientRect(hWnd,&r);			

	    Graphics graphics(hdc);

	    Pen blue(Color(255, 0, 0, 150)), lightBlue(Color(70, 0, 0, 255)), gray(Color(255, 150, 150, 150)), red(Color(255, 255, 0, 0)), bl(Color(255, 0, 0, 0)), green(Color(255,0,255,0)), magenta(Color(155, 255, 0, 155));
	    Color black(255,0,0,0), gr(255,150,150,150), greenCol(255,0,155,50);
	    Font f(FontFamily::GenericMonospace(), 8);
	    Font fSyndr(FontFamily::GenericSansSerif(), 12);
	    SolidBrush b(black), g(gr), greenBr(greenCol);

        if (pGlobalData->captureScreen) {
	        CaptureEx   capture;

            capture.CaptureWindow(hWnd, 1, (LPCTSTR) pGlobalData->capturePath, TRUE);
	        pGlobalData->captureScreen = FALSE;
        }

	    EndPaint(hWnd, &ps);
	}
	else {
        CCommonFnc::Graph_PlotNoData(pGlobalData, hWnd);
	}

    return status;
}

int CCommonFnc::Graph_PlotNoData(GRAPH_DATA* pGlobalData, HWND hWnd) {
	int             status = STAT_OK;
	RECT            r;
	HDC             hdc;
	PAINTSTRUCT     ps;

	hdc = BeginPaint(hWnd, &ps);
    GetClientRect(hWnd,&r);			

    Graphics graphics(hdc);
	Pen green(Color(255,0,255,0));
	Color black(255,0,0,0);
	Font f(FontFamily::GenericMonospace(), 14);
	SolidBrush b(black);

	graphics.DrawString(L"No data",-1,&f,PointF((float)(r.right/2-50),(float)(r.bottom/2+30)),&b);

	EndPaint(hWnd, &ps);

    return status;
}

int CCommonFnc::Graph_WM_HSCROLL(GRAPH_DATA* pGlobalData, HWND hWnd, SCROLLINFO* pSi, WPARAM wParam, int resizeRatio) {
	int             status = STAT_OK;
	RECT            r;

	GetClientRect(hWnd,&r);
	pSi->cbSize=sizeof(SCROLLINFO);
	pSi->fMask=SIF_ALL;		
	GetScrollInfo(hWnd,SB_HORZ,pSi);
	
	switch(LOWORD(wParam))
	{			
	case SB_LINELEFT:
		if(pSi->nPos>1)pSi->nPos = pSi->nPos - 10 * resizeRatio; break;
	case SB_PAGELEFT: 
		if(pSi->nPos>r.right)pSi->nPos-=r.right * resizeRatio; else pSi->nPos=1; break;
	case SB_LINERIGHT:
		if(pSi->nPos<pSi->nMax)pSi->nPos = pSi->nPos + 10 * resizeRatio; break;
	case SB_PAGERIGHT:
		if((pSi->nPos+r.right)<=pSi->nMax)pSi->nPos+=r.right * resizeRatio; else pSi->nPos=pSi->nMax-r.right * resizeRatio;
		break;
	case SB_RIGHT:
		pSi->nPos=pSi->nMax-r.right * resizeRatio;
		break;
	case SB_LEFT:
		pSi->nPos=1;
		break;
	case SB_ENDSCROLL:
        InvalidateRect(hWnd,NULL,TRUE);
		break;
	case SB_THUMBTRACK:
	    pSi->fMask=SIF_TRACKPOS;		
	    GetScrollInfo(hWnd,SB_HORZ,pSi);
        pSi->nPos = pSi->nTrackPos;
		//pSi->nPos=HIWORD(wParam);// NOTE: RETURN ONLY 16-bit NUMBER

		if(pSi->nPos>pSi->nMax-r.right)pSi->nPos=pSi->nMax-r.right * resizeRatio;
		InvalidateRect(hWnd,NULL,TRUE);
		break;
	case SB_THUMBPOSITION:
	    pSi->fMask=SIF_TRACKPOS;		
	    GetScrollInfo(hWnd,SB_HORZ,pSi);
        pSi->nPos = pSi->nTrackPos;
		//pSi->nPos=HIWORD(wParam); // NOTE: RETURN ONLY 16-bit NUMBER
		if(pSi->nPos>(int)pSi->nMax-r.right * resizeRatio)pSi->nPos=pSi->nMax-r.right * resizeRatio;
		break;
	}						
	SetScrollPos(hWnd,SB_HORZ,pSi->nPos,TRUE);

	pGlobalData->global_horizontal=pSi->nPos;		

    return status;
}
