// KeyInfectTab.cpp : implementation file
//

#include "stdafx.h"
#include "SensorSim.h"
#include "KeyInfectTab.h"
#include "SensorSimCore.h"
#include "SensorSimDlg.h"
#include "ScriptAction.h"

#include "ga/GASStateGA.h"
#include "ga/GASimpleGA.h"
#include "GAS_Genome.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CSensorSimCore*  pSensorSim;
extern CSensorSimDlg*  pSensorSimDlg;

float maxFit = 0;

/////////////////////////////////////////////////////////////////////////////
// CKeyInfectTab dialog


CKeyInfectTab::CKeyInfectTab(CWnd* pParent /*=NULL*/)
	: CDialog(CKeyInfectTab::IDD, pParent)
    , m_numGener(_T("1000000"))
    , m_populSize(_T("5"))
    , m_maxInstr(_T("200"))
    , m_mutationProb(_T("0.1"))
    , m_crossOverProb(_T("0"))
    , m_numParties(_T("3"))
    , m_nodeMemorySize(_T("12"))
    , m_prunneResults(FALSE)
    , m_UseSfnc(FALSE)
    , m_sfncSlots(_T("1"))
    , m_sfncSize(_T("200"))
    , m_cellsPerAxis(_T("3"))
    , m_autoKeyDiscover(FALSE)
    , m_mutualRelative(TRUE)
    , m_numDeployments("1")
    , m_useWithFOE(FALSE)
    , m_groupProtocolSubFunctIdependent(FALSE)
    , m_addMoreDeploymentsFitnessTreshold(FALSE)
    , m_moreDeploymentsCounter(_T("5"))
    , m_moreDeploymentsTreshold(_T("0.6"))
    , m_minimizeProtocolMessages(FALSE)
    , m_fitStableGeners(_T("10"))
{
	//{{AFX_DATA_INIT(CKeyInfectTab)
	m_rossAplifWhisper = TRUE;
	m_rossAplifMaxScream = FALSE;	// @TODO: not used anymore?
	m_plainMaxScream = FALSE;
	m_basicWhisper = TRUE;
	m_mutualWhisper = TRUE;
	m_amplifRepeat = _T("2");
	m_danAmplifWhisper = TRUE;
	m_rossAmplifMutualWhisper = FALSE;
	m_danAmplifMutualWhisper = FALSE;
	m_useEGScheme = FALSE;
	m_useMMD = FALSE;
	m_textProtocol = " : RNG 1 N3 1\r\n : SND 1 N3 N1 1 1\r\n : SND 1 N3 N2 1 1\r\n";
//	m_textProtocol = " : RNG 1 N1 1\r\n : RNG 1 N2 1\r\n : SND 1 N1 N2 1 2\r\n : SND 1 N2 N1 1 2\r\n";
//    m_textProtocol = "FNC:0 ---\r\n : RNG 1 N_2_ Rt11\r\n : SND 1 N_2_ N0.00_0.00 Rv11 Rt12\r\n : SND 1 N0.00_0.00 N_1_ Rv12 Rt6\r\n";

    m_GAProtocolType = 1;
	//}}AFX_DATA_INIT
}


void CKeyInfectTab::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CKeyInfectTab)
    DDX_Check(pDX, IDC_ROSS_AMPLIF_WHISPER, m_rossAplifWhisper);
    DDX_Check(pDX, IDC_PLAIN_MAX_SCREAM, m_plainMaxScream);
    DDX_Check(pDX, IDC_BASIC_WHISPER, m_basicWhisper);
    DDX_Check(pDX, IDC_MUTUAL_WHISPER, m_mutualWhisper);
    DDX_Text(pDX, IDC_AMPLIF_REPEAT, m_amplifRepeat);
    DDV_MaxChars(pDX, m_amplifRepeat, 2);
    DDX_Check(pDX, IDC_DAN_AMPLIF_WHISPER, m_danAmplifWhisper);
    DDX_Check(pDX, IDC_ROSS_AMPLIF_MUTUAL_WHISPER, m_rossAmplifMutualWhisper);
    DDX_Check(pDX, IDC_DANS_AMPLIF_MUTUAL_WHISPER, m_danAmplifMutualWhisper);
    DDX_Check(pDX, IDC_USE_EG_SCHEME, m_useEGScheme);
    DDX_Check(pDX, IDC_USE_MMD, m_useMMD);
    //}}AFX_DATA_MAP
    DDX_Text(pDX, IDC_NUM_GENER, m_numGener);
    DDX_Text(pDX, IDC_POPULATION_SIZE, m_populSize);
    DDX_Text(pDX, IDC_MAX_INSTR, m_maxInstr);
    DDX_Text(pDX, IDC_MUTATION_PROB, m_mutationProb);
    DDX_Text(pDX, IDC_CROSSOVER_PROB, m_crossOverProb);
    DDX_Text(pDX, IDC_MAX_PARTIES, m_numParties);
    DDX_Text(pDX, IDC_NODE_MEMORY_SIZE, m_nodeMemorySize);
    DDX_Text(pDX, IDC_TEXT_PROTOCOL, m_textProtocol);
    DDX_Check(pDX, IDC_PRUNNE_RESULTS, m_prunneResults);
    DDX_Check(pDX, IDC_SFNC_USE, m_UseSfnc);
    DDX_Text(pDX, IDC_SFNC_COUNT, m_sfncSlots);
    DDX_Text(pDX, IDC_SFNC_SIZE, m_sfncSize);
    DDX_Text(pDX, IDC_CELLS_PER_AXIS, m_cellsPerAxis);
    DDX_Text(pDX, IDC_NUM_DEPLOYMENTS, m_numDeployments);
    DDX_Check(pDX, IDC_AUTO_KEY_DISCOVER, m_autoKeyDiscover);
    DDX_Radio(pDX, IDC_RADIO_PROTOCOL_TYPE, m_GAProtocolType);
    DDX_Check(pDX, IDC_MUTUAL_RELATIVE_DIST, m_mutualRelative);
    DDX_Check(pDX, IDC_USE_WITH_FOE, m_useWithFOE);
    DDX_Check(pDX, IDC_GROUPPROT_INDEPENDENTSUBFUNCT, m_groupProtocolSubFunctIdependent);
    DDX_Check(pDX, IDC_ADD_MORE_DEPLOYMENTS, m_addMoreDeploymentsFitnessTreshold);
    DDX_Text(pDX, IDC_MORE_DEPLYMENTS_COUNT, m_moreDeploymentsCounter);
    DDX_Text(pDX, IDC_MORE_DEPOYMENTS_TRESHOLD, m_moreDeploymentsTreshold);
    DDX_Check(pDX, IDC_MINIMALIZE_MSG, m_minimizeProtocolMessages);
    DDX_Text(pDX, IDC_STABLE_GENERS, m_fitStableGeners);
}


BEGIN_MESSAGE_MAP(CKeyInfectTab, CDialog)
	//{{AFX_MSG_MAP(CKeyInfectTab)
	ON_BN_CLICKED(IDC_DEPLOY_SENSORS, OnDeploySensors)
	ON_BN_CLICKED(IDC_RECALCULATE, OnRecalculate)
    ON_BN_CLICKED(IDC_SCRIPTINFECT_RUN, OnBnClickedScriptinfectRun)
	//}}AFX_MSG_MAP
//    ON_BN_CLICKED(IDC_SCRIPTINFECT_RUN, &CKeyInfectTab::OnBnClickedScriptinfectRun)
ON_BN_CLICKED(IDC_GA_SCRIPT, &CKeyInfectTab::OnBnClickedGaScript)
ON_BN_CLICKED(IDC_EXECUTE_FROMTEXT, &CKeyInfectTab::OnBnClickedExecuteFromtext)
ON_BN_CLICKED(IDC_RESTART_FROMFILE, &CKeyInfectTab::OnBnClickedRestartFromfile)
ON_BN_CLICKED(IDC_BLACK_PATTERN, &CKeyInfectTab::OnBnClickedBlackPattern)
ON_BN_CLICKED(IDC_WHITE_PATTERN, &CKeyInfectTab::OnBnClickedWhitePattern)
ON_BN_CLICKED(IDC_BLACKWHITE_PATTERN_EVOLUTION, &CKeyInfectTab::OnBnClickedBlackwhitePatternEvolution)
ON_BN_CLICKED(IDC_LOAD_BLACK_PATTERN, &CKeyInfectTab::OnBnClickedLoadBlackPattern)
ON_BN_CLICKED(IDC_LOAD_WHITE_PATTERN, &CKeyInfectTab::OnBnClickedLoadWhitePattern)
ON_BN_CLICKED(IDC_FIND_INS_DEPENDENCY, &CKeyInfectTab::OnBnClickedFindInsDependency)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CKeyInfectTab message handlers
void CKeyInfectTab::DeploySensors(BASIC_INIT_DATA* pBasicSettings){
	float               avgSecureLinks = 0;
    float               avgWhiteNeigh = 0;
    
	// INIT RANDOM GENERATOR
    pSensorSim->m_sensorEnv.InitRandomGenerator(pBasicSettings);

    // #ALL DEPLOYMENTS
	for (int i = 0; i < pBasicSettings->numDeployments; i++) {
		CString message;
		message.Format("DEPLOYMENT #%d", i);
		LOG_INSERTSTRING(message);

			
		// set actual deployment
		pSensorSim->m_sensorEnv.m_pActualDeployment = pSensorSim->m_sensorEnv.m_deploymentList[i];

		// DEPLOY SENSORS
		pSensorSim->m_sensorEnv.DeploySensors(pBasicSettings);
	        
		//TODO - should be FLAG_DISTRIB_SKIPDISTRIBMARKRANDOMLY code here?
        // IF REQUIRED, SET LINK KEYS COMPROMITATION STATUS RANDONMLY 
        if (pBasicSettings->distribFlags & FLAG_DISTRIB_SKIPDISTRIBMARKRANDOMLY) {
            DWORD   secure = 0;   
            DWORD   compr = 0;

            pSensorSim->m_sensorEnv.DistributeKeyStatusRandomly(pBasicSettings, &secure, &compr, FLAG_RANDOMDISTRIB_BIDIRECTIONAL, TRUE);
        }
	    
		// COMPUTE STATISTICS
		float   bestSecureRatio = 0;
		float   avgWhite = 0;
		ComputeStatistics(pBasicSettings, &bestSecureRatio, &avgWhite);
		avgSecureLinks += bestSecureRatio;
		avgWhiteNeigh += avgWhite;
		pSensorSim->m_sensorEnv.m_pActualDeployment->avgWhiteNeigh = avgWhite;
	}

	// set again first deployment struct
	pSensorSim->m_sensorEnv.m_pActualDeployment = pSensorSim->m_sensorEnv.m_deploymentList[0];
		
	CString     message;
	avgSecureLinks /= pBasicSettings->numDeployments;
	avgWhiteNeigh /= pBasicSettings->numDeployments;
    message.Format("AVG. SECURE LINKS: %.2f%s, AVG. WHITE NEIGH: %.2f", avgSecureLinks * 100, "%", avgWhiteNeigh);
    LOG_INSERTSTRING(message);
}
void CKeyInfectTab::OnDeploySensors() 
{
    int     status = STAT_OK;
    BASIC_INIT_DATA     basicSettings;
    
    UpdateData(TRUE);
 
    LOG_INSERTSEPARATOR;
    
    // LOAD INSERTED DATA
    if ((status = pSensorSimDlg->GetBasicSettings(&basicSettings)) == STAT_OK) {
		DeploySensors(&basicSettings);
    }	
}

void CKeyInfectTab::OnRecalculate() 
{
    int     status = STAT_OK;
    BASIC_INIT_DATA     basicSettings;
    float               avgSecureLinks = 0;
    float               avgWhiteNeigh = 0;
    
    UpdateData(TRUE);
 
    LOG_INSERTSEPARATOR;
    
    // LOAD INSERTED DATA
    if ((status = pSensorSimDlg->GetBasicSettings(&basicSettings)) == STAT_OK) {
        // #ALL DEPLOYMENTS
		for (int i = 0; i < basicSettings.numDeployments; i++) {
			CString message;
			message.Format("DEPLOYMENT #%d", i);
			LOG_INSERTSTRING(message);

			// set actual deployment
			pSensorSim->m_sensorEnv.m_pActualDeployment = pSensorSim->m_sensorEnv.m_deploymentList[i];

            // RE-COMPUTE STATISTICS
            pSensorSim->m_sensorEnv.ResetNetwork();
			// COMPUTE STATISTICS
			float   bestSecureRatio = 0;
			float   avgWhite = 0;
			ComputeStatistics(&basicSettings, &bestSecureRatio, &avgWhite);
			avgSecureLinks += bestSecureRatio;
			avgWhiteNeigh += avgWhite;
		}

		// set again first deployment struct
		pSensorSim->m_sensorEnv.m_pActualDeployment = pSensorSim->m_sensorEnv.m_deploymentList[0];
		
		CString     message;
		avgSecureLinks /= basicSettings.numDeployments;
		avgWhiteNeigh /= basicSettings.numDeployments;
        message.Format("AVG. SECURE LINKS: %.2f%s, AVG. WHITE NEIGH: %.2f", avgSecureLinks * 100, "%", avgWhiteNeigh);
        LOG_INSERTSTRING(message);
        
    }	
}

int CKeyInfectTab::ComputeStatistics(BASIC_INIT_DATA* pBasicSettings, float* pBestSecureFraction, float* pAvgWhite) {
    int     status = STAT_OK;
    DWORD   secure = 0;
    DWORD   compr = 0;
    DWORD   max;
    DWORD   min;
    float   avg;
    float   blackArea;
    CString message;
    CString fileName;
    MMD_TEST_RESULTS mmdResults;
	double	avgHopLen = 0;
	int     bestSecure = 0;
	int     bestSecureCompr = 0;

    // COMPUTE STATISTICS
    message.Format("Total white: %d, total black: %d", pBasicSettings->whiteNum, pBasicSettings->blackNum);
    LOG_INSERTSTRING(message);

    pSensorSim->m_sensorEnv.CalcWhiteNeighStats(&max, &min, &avg);
    message.Format("White neighbours -- max: %d | min: %d | avg: %0.1f", max, min, avg);
    LOG_INSERTSTRING(message);
    
    if (pAvgWhite) *pAvgWhite = avg;

    pSensorSim->m_sensorEnv.CalcBlackNeighStats(&max, &min, &avg);
    message.Format("Black neighbours -- max: %d | min: %d | avg: %0.1f", max, min, avg);
    LOG_INSERTSTRING(message);

    pSensorSim->m_sensorEnv.CalcBlackAreaStats(pBasicSettings, &blackArea);
    message.Format("Area covered by black -- %.2f", blackArea);
    LOG_INSERTSTRING(message);


    // MULTIPATH MESSAGE DELIVERY EXTENSION
    if (status == STAT_OK && pBasicSettings->distribFlags & FLAG_DISTRIB_USEMULTIPATHMESSAGEDELIVERY) {
        status = pSensorSim->m_sensorEnv.MMD_CreateRoutingPaths(pBasicSettings, &avgHopLen);
        message.Format("Avg Hop Length :%f", avgHopLen);
        LOG_INSERTSTRING(message);
    }

	if (pBasicSettings->plainMaxScream) {
        secure = compr = 0;
        pSensorSim->m_sensorEnv.ClearLinkKeysStatus();
        pSensorSim->m_sensorEnv.PlaintextMaxScream(pBasicSettings, &secure, &compr);
        message.Format("Maximal screaming -- total:%d | secure: %.2f%s | compromised: %.2f%s", secure + compr, (secure / (float) (secure + compr)) * 100, "%", (compr / (float) (secure + compr)) * 100, "%");
        LOG_INSERTSTRING(message);

        if (secure > bestSecure) { bestSecure = secure; bestSecureCompr = compr; }

        if (pBasicSettings->distribFlags & FLAG_DISTRIB_USEMULTIPATHMESSAGEDELIVERY) 
			pSensorSim->m_sensorEnv.MMD_Test(pBasicSettings, &mmdResults);
    }

	if (pBasicSettings->basicWhisper) {
        secure = compr = 0;
        pSensorSim->m_sensorEnv.ClearLinkKeysStatus();
        pSensorSim->m_sensorEnv.BasicWhisper(pBasicSettings, &secure, &compr);
        message.Format("Basic whispering    -- total:%d | secure: %.2f%s | compromised: %.2f%s", secure + compr, (secure / (float) (secure + compr)) * 100, "%", (compr / (float) (secure + compr)) * 100, "%");
        LOG_INSERTSTRING(message);

        if (secure > bestSecure) { bestSecure = secure; bestSecureCompr = compr; }

        if (pBasicSettings->distribFlags & FLAG_DISTRIB_USEMULTIPATHMESSAGEDELIVERY) 
			pSensorSim->m_sensorEnv.MMD_Test(pBasicSettings, &mmdResults);
    }

    if (pBasicSettings->mutualWhisper) {
        secure = compr = 0;
        pSensorSim->m_sensorEnv.ClearLinkKeysStatus();
        pSensorSim->m_sensorEnv.MutualWhisper(pBasicSettings, &secure, &compr);
        message.Format("Mutual whispering  -- total:%d | secure: %.2f%s | compromised: %.2f%s", secure + compr, (secure / (float) (secure + compr)) * 100, "%", (compr / (float) (secure + compr)) * 100, "%");
        LOG_INSERTSTRING(message);

        if (secure > bestSecure) { bestSecure = secure; bestSecureCompr = compr; }

        if (pBasicSettings->distribFlags & FLAG_DISTRIB_USEMULTIPATHMESSAGEDELIVERY) 
			pSensorSim->m_sensorEnv.MMD_Test(pBasicSettings, &mmdResults);
    }

	/*
	if (m_rossAplifMaxScream) {
        secure = compr = 0;
        pSensorSim->m_sensorEnv.ClearLinkKeysStatus();
        pSensorSim->m_sensorEnv.RossAmplifMaxScream(pBasicSettings, &secure, &compr);

        if (secure > bestSecure) { bestSecure = secure; bestSecureCompr = compr; }

        if (pBasicSettings->distribFlags & FLAG_DISTRIB_USEMULTIPATHMESSAGEDELIVERY) 
			pSensorSim->m_sensorEnv.MMD_Test(pBasicSettings, &mmdResults);
    }
	*/

	if (pBasicSettings->rossAmplifWhisper) {
        secure = compr = 0;
        
        pSensorSim->m_sensorEnv.ClearLinkKeysStatus();
        pSensorSim->m_sensorEnv.RossAmplifWhisper(pBasicSettings, &secure, &compr, 1);
        message.Format("Amplif basic whispering (1x) -- total:%d | secure: %.2f%s | compromised: %.2f%s", secure + compr, (secure / (float) (secure + compr)) * 100, "%", (compr / (float) (secure + compr)) * 100, "%");
        LOG_INSERTSTRING(message);
        
        if (secure > bestSecure) { bestSecure = secure; bestSecureCompr = compr; }
        
        if (pBasicSettings->distribFlags & FLAG_DISTRIB_USEMULTIPATHMESSAGEDELIVERY) 
			pSensorSim->m_sensorEnv.MMD_Test(pBasicSettings, &mmdResults);

        secure = compr = 0;
		if (pBasicSettings->amplifRepeat > 1) {
            pSensorSim->m_sensorEnv.RossAmplifWhisper(pBasicSettings, &secure, &compr, pBasicSettings->amplifRepeat);
            message.Format("Amplif basic whispering (%dx) -- total:%d | secure: %.2f%s | compromised: %.2f%s", pBasicSettings->amplifRepeat, secure + compr, (secure / (float) (secure + compr)) * 100, "%", (compr / (float) (secure + compr)) * 100, "%");
            LOG_INSERTSTRING(message);

            if (secure > bestSecure) { bestSecure = secure; bestSecureCompr = compr; }

            if (pBasicSettings->distribFlags & FLAG_DISTRIB_USEMULTIPATHMESSAGEDELIVERY) 
				pSensorSim->m_sensorEnv.MMD_Test(pBasicSettings, &mmdResults);
        }
    }
	
	if (pBasicSettings->rossAmplifMutualWhisper) {
        secure = compr = 0;
        
        pSensorSim->m_sensorEnv.ClearLinkKeysStatus();
        pSensorSim->m_sensorEnv.RossAmplifMutualWhisper(pBasicSettings, &secure, &compr, 1);
        message.Format("Amplif mutual whispering (1x) -- total:%d | secure: %.2f%s | compromised: %.2f%s", secure + compr, (secure / (float) (secure + compr)) * 100, "%", (compr / (float) (secure + compr)) * 100, "%");
        LOG_INSERTSTRING(message);
        
        if (secure > bestSecure) { bestSecure = secure; bestSecureCompr = compr; }
        
        if (pBasicSettings->distribFlags & FLAG_DISTRIB_USEMULTIPATHMESSAGEDELIVERY) 
			pSensorSim->m_sensorEnv.MMD_Test(pBasicSettings, &mmdResults);

        secure = compr = 0;
        if (pBasicSettings->amplifRepeat > 1) {
            pSensorSim->m_sensorEnv.RossAmplifMutualWhisper(pBasicSettings, &secure, &compr, pBasicSettings->amplifRepeat);
            message.Format("Amplif mutual whispering (%dx) -- total:%d | secure: %.2f%s | compromised: %.2f%s", pBasicSettings->amplifRepeat, secure + compr, (secure / (float) (secure + compr)) * 100, "%", (compr / (float) (secure + compr)) * 100, "%");
            LOG_INSERTSTRING(message);
    
            if (secure > bestSecure) { bestSecure = secure; bestSecureCompr = compr; }
    
            if (pBasicSettings->distribFlags & FLAG_DISTRIB_USEMULTIPATHMESSAGEDELIVERY) 
				pSensorSim->m_sensorEnv.MMD_Test(pBasicSettings, &mmdResults);
        }
    }

	if (pBasicSettings->danAmplifWhisper) {
        secure = compr = 0;
        pSensorSim->m_sensorEnv.ClearLinkKeysStatus();
        pSensorSim->m_sensorEnv.DanAmplifWhisper(pBasicSettings, &secure, &compr, 1);
        message.Format("Dan amplif whispering -- total:%d | secure: %.2f%s | compromised: %.2f%s", secure + compr, (secure / (float) (secure + compr)) * 100, "%", (compr / (float) (secure + compr)) * 100, "%");
        LOG_INSERTSTRING(message);
        
        if (secure > bestSecure) { bestSecure = secure; bestSecureCompr = compr; }
        
        if (pBasicSettings->distribFlags & FLAG_DISTRIB_USEMULTIPATHMESSAGEDELIVERY) 
			pSensorSim->m_sensorEnv.MMD_Test(pBasicSettings, &mmdResults);

        secure = compr = 0;
        if (pBasicSettings->amplifRepeat > 1) {
            pSensorSim->m_sensorEnv.DanAmplifWhisper(pBasicSettings, &secure, &compr, pBasicSettings->amplifRepeat);
            message.Format("Dan amplif basic whispering (%dx) -- total:%d | secure: %.2f%s | compromised: %.2f%s", pBasicSettings->amplifRepeat, secure + compr, (secure / (float) (secure + compr)) * 100, "%", (compr / (float) (secure + compr)) * 100, "%");
            LOG_INSERTSTRING(message);
            
            if (secure > bestSecure) { bestSecure = secure; bestSecureCompr = compr; }
            
            if (pBasicSettings->distribFlags & FLAG_DISTRIB_USEMULTIPATHMESSAGEDELIVERY) 
				pSensorSim->m_sensorEnv.MMD_Test(pBasicSettings, &mmdResults);
        }
    }

	if (pBasicSettings->danAmplifMutualWhisper) {
        secure = compr = 0;
        pSensorSim->m_sensorEnv.ClearLinkKeysStatus();
        pSensorSim->m_sensorEnv.DanAmplifMutualWhisper(pBasicSettings, &secure, &compr, 1);
        message.Format("Dan amplif mutual whispering -- total:%d | secure: %.2f%s | compromised: %.2f%s", secure + compr, (secure / (float) (secure + compr)) * 100, "%", (compr / (float) (secure + compr)) * 100, "%");
        LOG_INSERTSTRING(message);
        
        if (secure > bestSecure) { bestSecure = secure; bestSecureCompr = compr; }
        
        if (pBasicSettings->distribFlags & FLAG_DISTRIB_USEMULTIPATHMESSAGEDELIVERY) 
			pSensorSim->m_sensorEnv.MMD_Test(pBasicSettings, &mmdResults);

        secure = compr = 0;
        if (pBasicSettings->amplifRepeat > 1) {
            pSensorSim->m_sensorEnv.DanAmplifMutualWhisper(pBasicSettings, &secure, &compr, pBasicSettings->amplifRepeat);
            message.Format("Dan amplif mutual whispering (%dx) -- total:%d | secure: %.2f%s | compromised: %.2f%s", pBasicSettings->amplifRepeat, secure + compr, (secure / (float) (secure + compr)) * 100, "%", (compr / (float) (secure + compr)) * 100, "%");
            LOG_INSERTSTRING(message);
    
            if (secure > bestSecure) { bestSecure = secure; bestSecureCompr = compr; }
    
            if (pBasicSettings->distribFlags & FLAG_DISTRIB_USEMULTIPATHMESSAGEDELIVERY) 
				pSensorSim->m_sensorEnv.MMD_Test(pBasicSettings, &mmdResults);
        }
    }


    if (pBestSecureFraction && bestSecure > 0) *pBestSecureFraction = bestSecure / (float) (bestSecure + bestSecureCompr);


    return STAT_OK;
}

int CKeyInfectTab::GetGASettings(GA_STRATEGY* pStrategy) {
	UpdateData(TRUE);
	    
    pStrategy->prunneResults = m_prunneResults;
    pStrategy->autoKeyDiscovery = m_autoKeyDiscover;
    pStrategy->numRepeat = atoi(m_amplifRepeat);
    pStrategy->maxParties = atoi(m_numParties);
    pStrategy->partyMemorySize = atoi(m_nodeMemorySize);
    pStrategy->maxInstruct = atoi(m_maxInstr);
    pStrategy->sfncSlots = atoi(m_sfncSlots);
    pStrategy->sfncSize = atoi(m_sfncSize);
    pStrategy->useSubFunct = m_UseSfnc;
    pStrategy->pMutt = atof(m_mutationProb);
    pStrategy->pCross = atof(m_crossOverProb);
    pStrategy->popSize = atoi(m_populSize);
    pStrategy->nGeners = atoi(m_numGener);
    pStrategy->numRepeat = atoi(m_amplifRepeat);
    pStrategy->sfncCount = (pStrategy->useSubFunct) ? (pStrategy->maxInstruct / pStrategy->sfncSize) : 0; // COUNT NUMBER OF SUBFUNCTION PARTS
    pStrategy->gLength = pStrategy->maxInstruct * GAS_INSLENGTH + pStrategy->sfncCount * GAS_INSLENGTH; // TOTAL GENOM LENGTH
    pStrategy->bAddDeploymentsFitnessTreshold = m_addMoreDeploymentsFitnessTreshold;
    pStrategy->moreDeploymentsCounter = atoi(m_moreDeploymentsCounter);
    pStrategy->moreDeploymentsTreshold = atof(m_moreDeploymentsTreshold);
    pStrategy->fitnessStableGenersTreshold = atoi(m_fitStableGeners);

    switch (m_GAProtocolType) {
        case 0: pStrategy->protocolTypeFlags |= FLAG_PROTOCOL_NODESORIENTED; break;
        case 1: pStrategy->protocolTypeFlags |= FLAG_PROTOCOL_GROUPORIENTED; break;
        default: ASSERT(FALSE);
    }
    if (m_mutualRelative) pStrategy->protocolTypeFlags |= FLAG_PROTOCOL_MUTUALRELATIVEDISTANCE;
    if (m_groupProtocolSubFunctIdependent) pStrategy->protocolTypeFlags |= FLAG_PROTOCOL_GROUP_INDEPENDENTEXECUTION;
    if (m_minimizeProtocolMessages) pStrategy->protocolTypeFlags |= FLAG_PROTOCOL_GROUP_MINIMIZEMESSAGES;

    pStrategy->blackDeployPattern.numCellPerAxis = atoi(m_cellsPerAxis);            
    pStrategy->whiteDeployPattern.numCellPerAxis = atoi(m_cellsPerAxis);            
    
    return STAT_OK;
}

int CKeyInfectTab::SetGASettings(GA_STRATEGY* pStrategy) {
    
    m_prunneResults = pStrategy->prunneResults;
    m_autoKeyDiscover = pStrategy->autoKeyDiscovery;
    m_numParties.Format("%d", pStrategy->maxParties);
    m_nodeMemorySize.Format("%d", pStrategy->partyMemorySize);
    m_maxInstr.Format("%d", pStrategy->maxInstruct);
    m_sfncSlots.Format("%d", pStrategy->sfncSlots);
	m_sfncSize.Format("%d", pStrategy->sfncSize);
    m_UseSfnc = pStrategy->useSubFunct;
    m_mutationProb.Format("%.3f", pStrategy->pMutt);
    m_crossOverProb.Format("%.3f", pStrategy->pCross);
    m_populSize.Format("%d", pStrategy->popSize);
    m_numGener.Format("%d", pStrategy->nGeners);
    m_amplifRepeat.Format("%d", pStrategy->numRepeat);
    m_addMoreDeploymentsFitnessTreshold = pStrategy->bAddDeploymentsFitnessTreshold;
    m_moreDeploymentsCounter.Format("%d", pStrategy->moreDeploymentsCounter);
    m_moreDeploymentsTreshold.Format("%.3f", pStrategy->moreDeploymentsTreshold);
    m_fitStableGeners.Format("%d", pStrategy->fitnessStableGenersTreshold);

    if (pStrategy->protocolTypeFlags & FLAG_PROTOCOL_NODESORIENTED) m_GAProtocolType = 0;
    if (pStrategy->protocolTypeFlags & FLAG_PROTOCOL_GROUPORIENTED) m_GAProtocolType = 1;

	m_mutualRelative = (pStrategy->protocolTypeFlags & FLAG_PROTOCOL_MUTUALRELATIVEDISTANCE) ? TRUE : FALSE;
	m_groupProtocolSubFunctIdependent = (pStrategy->protocolTypeFlags & FLAG_PROTOCOL_GROUP_INDEPENDENTEXECUTION) ? TRUE : FALSE;
	m_minimizeProtocolMessages = (pStrategy->protocolTypeFlags & FLAG_PROTOCOL_GROUP_MINIMIZEMESSAGES) ? TRUE : FALSE;

    m_cellsPerAxis.Format("%d", pStrategy->blackDeployPattern.numCellPerAxis);            
    m_cellsPerAxis.Format("%d", pStrategy->whiteDeployPattern.numCellPerAxis);            
    
    UpdateData(FALSE);
    return STAT_OK;
}

int CKeyInfectTab::GetDlgData(BASIC_INIT_DATA* pBasicSettings) {
    int     status = STAT_OK;

    UpdateData(TRUE);
    pBasicSettings->plainMaxScream = m_plainMaxScream;
    pBasicSettings->basicWhisper = m_basicWhisper;
    pBasicSettings->mutualWhisper = m_mutualWhisper;
    pBasicSettings->rossAmplifWhisper = m_rossAplifWhisper;
    pBasicSettings->danAmplifWhisper = m_danAmplifWhisper;
    pBasicSettings->rossAmplifMutualWhisper = m_rossAmplifMutualWhisper;
    pBasicSettings->danAmplifMutualWhisper = m_danAmplifMutualWhisper;
    pBasicSettings->amplifRepeat = (BYTE) atoi(m_amplifRepeat);
	pBasicSettings->numDeployments = (BYTE) atoi(m_numDeployments);
    if (m_useEGScheme) pBasicSettings->distribFlags |= FLAG_DISTRIB_USEEGSCHEME;
    if (m_useMMD) pBasicSettings->distribFlags |= FLAG_DISTRIB_USEMULTIPATHMESSAGEDELIVERY;
    if (m_useWithFOE) pBasicSettings->distribFlags |= FLAG_DISTRIB_USEFORWARDONIONENCRYPTION;

	GetGASettings(&(pBasicSettings->gaConfig));

    return status;
}

int CKeyInfectTab::SetDlgData(BASIC_INIT_DATA* pBasicSettings) {
    int     status = STAT_OK;

    m_plainMaxScream = pBasicSettings->plainMaxScream;
    m_basicWhisper = pBasicSettings->basicWhisper;
    m_mutualWhisper = pBasicSettings->mutualWhisper;
    m_rossAplifWhisper = pBasicSettings->rossAmplifWhisper;
    m_danAmplifWhisper = pBasicSettings->danAmplifWhisper;
    m_rossAmplifMutualWhisper = pBasicSettings->rossAmplifMutualWhisper;
    m_danAmplifMutualWhisper = pBasicSettings->danAmplifMutualWhisper;
    m_amplifRepeat.Format("%d", pBasicSettings->amplifRepeat);
	m_numDeployments.Format("%d", pBasicSettings->numDeployments);
    m_useEGScheme = (pBasicSettings->distribFlags & FLAG_DISTRIB_USEEGSCHEME) ? TRUE : FALSE;
    m_useMMD = (pBasicSettings->distribFlags & FLAG_DISTRIB_USEMULTIPATHMESSAGEDELIVERY) ? TRUE : FALSE;
    m_useWithFOE = (pBasicSettings->distribFlags & FLAG_DISTRIB_USEFORWARDONIONENCRYPTION) ? TRUE : FALSE;

	SetGASettings(&(pBasicSettings->gaConfig));

    UpdateData(FALSE);

    return status;
}


void CKeyInfectTab::OnBnClickedScriptinfectRun()
{
/*
    lss             strats;
    SCRIPT_STRATEGY strategyWhisper;
    SCRIPT_STRATEGY strategyMutualWhisper;
    CAction*        pAction = NULL; 
    int             indexKeyAB;
    int             indexKeyBA;
    int             indexKeyComposite;
    int             indexSensorA;
    int             indexSensorB;
    int             indexMessageAB;
    int             indexMessageBA;
    int             messageIndexOffset;


    !!! pri druhem spusteni uz dava vzdy 100% hodnoty :(
        
    pSensorSim->m_sensorEnv.ResetNetwork();
    pSensorSim->m_sensorEnv.SS_ReleaseStructs();
/**/
    /*
    //
    // WHISPERING KEY FROM A TO NEIGBOUR B (UNIDIRECTION)
    //
    indexKeyAB = 1; 
    indexSensorA = 1; indexSensorB = 2; 
    messageIndexOffset = 2;
    indexMessageAB = messageIndexOffset;  
    
    // GENERATE NEW KEY (RANDOM VALUE)
    strategyWhisper.actionsList.push_back(new CNewKeyAction(indexKeyAB));
    // ADD KEY TO A's KEYRING 
    strategyWhisper.actionsList.push_back(new CAddKeyAction(indexKeyAB, indexSensorA));
    // CREATE MESSAGE FOR B WITH KEY INSIDE, NO KEY IS USED FOR ENCRYPTION
    strategyWhisper.actionsList.push_back(new CNewMessageAction_noKey(indexKeyAB, indexMessageAB)); 
    // SEND MESSAGE TO B
    strategyWhisper.actionsList.push_back(new CSendMessageAction(indexSensorA, indexSensorB, indexMessageAB));
    // ACCEPT MESSAGE AND EXTRACT KEY ON B SIDE.
    strategyWhisper.actionsList.push_back(new CDispatchMessageAction(indexSensorB));

    strategyWhisper.numNodes = 2;
    strategyWhisper.ptrCount_SENSITIVE_OBJECT = 1 + 1; // one key, one message  
    strategyWhisper.ptrCount_SENSOR_NODE = 2;  // two nodes
    
    strats.push_back(&strategyWhisper);
/**/
/*
    //
    // MUTUAL WHISPERING KEY BETWEEN A AND B 
    //
    indexKeyAB = 1; 
    indexKeyBA = 2; 
    indexKeyComposite = 3; 
    indexSensorA = 1; indexSensorB = 2; 
    messageIndexOffset = 4;
    indexMessageAB = messageIndexOffset;
    messageIndexOffset++;
    indexMessageBA = messageIndexOffset;  
    
    // GENERATE NEW KEY (RANDOM VALUE)
    strategyMutualWhisper.actionsList.push_back(new CNewKeyAction(indexKeyAB));
    // ADD KEY TO A's KEYRING 
    strategyMutualWhisper.actionsList.push_back(new CAddKeyAction(indexKeyAB, indexSensorA));
    // CREATE MESSAGE FOR B WITH KEY INSIDE, NO KEY IS USED FOR ENCRYPTION
    strategyMutualWhisper.actionsList.push_back(new CNewMessageAction_noKey(indexKeyAB, indexMessageAB)); 
    // SEND MESSAGE TO B
    strategyMutualWhisper.actionsList.push_back(new CSendMessageAction(indexSensorA, indexSensorB, indexMessageAB));
    // ACCEPT MESSAGE AND EXTRACT KEY ON B SIDE.
    strategyMutualWhisper.actionsList.push_back(new CDispatchMessageAction(indexSensorB));

    strategyMutualWhisper.actionsList.push_back(new CNewKeyAction(indexKeyBA));
    strategyMutualWhisper.actionsList.push_back(new CAddKeyAction(indexKeyBA, indexSensorB));
    strategyMutualWhisper.actionsList.push_back(new CNewMessageAction_noKey(indexKeyBA, indexMessageBA)); 
    strategyMutualWhisper.actionsList.push_back(new CSendMessageAction(indexSensorB, indexSensorA, indexMessageBA));
    strategyMutualWhisper.actionsList.push_back(new CDispatchMessageAction(indexSensorA));

    // COMBINE KEYS FROM A AND B
    strategyMutualWhisper.actionsList.push_back(new CCombineKeysAction(indexKeyAB, indexKeyBA, indexKeyComposite));
    strategyMutualWhisper.actionsList.push_back(new CAddKeyAction(indexKeyComposite, indexSensorA));
    strategyMutualWhisper.actionsList.push_back(new CAddKeyAction(indexKeyComposite, indexSensorB));
    

    strategyMutualWhisper.numNodes = 2;
    strategyMutualWhisper.ptrCount_SENSITIVE_OBJECT = 3 + 2; // three keys, two messages  
    strategyMutualWhisper.ptrCount_SENSOR_NODE = 2;  // two nodes
    
    strats.push_back(&strategyMutualWhisper);



    pSensorSim->m_sensorEnv.SS_ExecuteStrategies(&strats);
    strategyMutualWhisper.release();
    strategyWhisper.release();
/**/

    // GENERATE CHROMOZOM
    
    // MUTATE
    
    // CHECK FOR INVALID INSTRUCTIONS

    // EXECUTE INSTRUCTIONS
    
    // COMPUTE COMPROMITATION STATUS
    
    UpdateData(TRUE);
    
    DWORD           offset = 0;
    int     status = STAT_OK;
    BASIC_INIT_DATA     basicSettings;
    float               maxSecure = 0;
    CString             message;
    CString             value;
    BOOL                bInsChanged = FALSE;   
    
    //
    //  ALLOCATE STRATEGY RESOURCES
    //
    GA_STRATEGY     strategy;
    strategy.stratStringSize = 100 * GAS_INSLENGTH;
    strategy.stratString = new GAS_ELEMENT_TYPE[strategy.stratStringSize];
    memset(strategy.stratString, 0, strategy.stratStringSize * sizeof(GAS_ELEMENT_TYPE));
    strategy.secAmplifOffset = strategy.stratStringSize / 2;
    strategy.nodesSize = 10;
    strategy.nodes = new SENSOR_NODE*[strategy.nodesSize];
    memset(strategy.nodes, 0, sizeof(SENSOR_NODE*) * strategy.nodesSize);
    strategy.valuesInfoSize = 1000;
    strategy.valuesInfo = new VALUE_INFO[strategy.valuesInfoSize];
    memset(strategy.valuesInfo, 0, sizeof(VALUE_INFO) * strategy.valuesInfoSize);
    
//    pSensorSim->m_sensorEnv.GAS_PrepareMutualWhisperStrategy(&strategy);
    pSensorSim->m_sensorEnv.GAS_PrepareDanAmplifStrategy(&strategy);
//    pSensorSim->m_sensorEnv.GAS_PrepareRossAmplifStrategy(&strategy);

    strategy.numRepeat = 1;
    status = pSensorSim->m_sensorEnv.GAS_ExecuteStrategy(&strategy);
    message.Format("(1x) Total keys: '%d', Fitness: %f", strategy.totalKeys, strategy.fitness);
    pSensorSim->Log_InsertString(message);
    
    strategy.numRepeat = atoi(m_amplifRepeat);
    status = pSensorSim->m_sensorEnv.GAS_ExecuteStrategy(&strategy);
    message.Format("(%dx) Total keys: '%d', Fitness: %f", strategy.numRepeat, strategy.totalKeys, strategy.fitness);
    pSensorSim->Log_InsertString(message);
    
    delete[] strategy.stratString; 
    delete[] strategy.nodes;
    delete[] strategy.valuesInfo;
/**/    

    
}


UINT CKeyInfectTab::RunGAS(LPVOID pParam) {
    UINT                status = STAT_OK;

	//
    // ALLOCATE GENOM AND GA ALGORITHM, ONLY IF NOT PREPARED BEFORE (E.G. LOADED FROM FILE)
    //
    GAResetRNG(GAGetRandomSeed());    

    BOOL    bNewPopulation = FALSE;
    if (pSensorSim->m_pGAStrategy->pGA == NULL) {
		pSensorSim->m_pGAStrategy->pGenom = new GAS_Genome<GAS_ELEMENT_TYPE> (pSensorSim->m_pGAStrategy->gLength, CSensorEnv::GAS_fitness);
        if (pSensorSim->m_pGAStrategy->protocolTypeFlags & FLAG_PROTOCOL_NODESORIENTED) { 
            pSensorSim->m_pGAStrategy->pGenom->initializer(CSensorEnv::GAS_initializer_random); 
            pSensorSim->m_pGAStrategy->pGenom->mutator(CSensorEnv::GAS_mutator); 
            pSensorSim->m_pGAStrategy->pGenom->crossover(CSensorEnv::GAS_crossover); 
        }
        if (pSensorSim->m_pGAStrategy->protocolTypeFlags & FLAG_PROTOCOL_GROUPORIENTED) { 
            pSensorSim->m_pGAStrategy->pGenom->initializer(CSensorEnv::GAGS_initializer_random); 
            pSensorSim->m_pGAStrategy->pGenom->mutator(CSensorEnv::GAGS_mutator); 
            pSensorSim->m_pGAStrategy->pGenom->crossover(CSensorEnv::GAGS_crossover); 
        }
                    
        pSensorSim->m_pGAStrategy->pGA = new GASteadyStateGA(*(pSensorSim->m_pGAStrategy->pGenom));
        // FLAG AS NEW POPULATION
        bNewPopulation = TRUE;
    }        
        
    pSensorSim->m_pGAStrategy->pGA->nReplacement(2 * (pSensorSim->m_pGAStrategy->popSize / 3));  
    pSensorSim->m_pGAStrategy->pGA->populationSize(pSensorSim->m_pGAStrategy->popSize); 
    pSensorSim->m_pGAStrategy->pGA->nGenerations(pSensorSim->m_pGAStrategy->nGeners);
    pSensorSim->m_pGAStrategy->pGA->pCrossover(pSensorSim->m_pGAStrategy->pCross);
    pSensorSim->m_pGAStrategy->pGA->pMutation(pSensorSim->m_pGAStrategy->pMutt); 

    // INITIALIZE POPULATION
    if (bNewPopulation) {
        pSensorSim->m_pGAStrategy->pGA->initialize();
    }

    
    // 
    //  RUN EVOLUTION
    //
    status = pSensorSim->m_sensorEnv.GAS_Evolve(pSensorSim->m_pGAStrategy);
    
    //  RELEASE STRUCTS
    if (pSensorSim->m_pGAStrategy->pGenom) {
        delete pSensorSim->m_pGAStrategy->pGenom;
        pSensorSim->m_pGAStrategy->pGenom = NULL;
    }       
    if (pSensorSim->m_pGAStrategy->pGA) {
        delete pSensorSim->m_pGAStrategy->pGA;
        pSensorSim->m_pGAStrategy->pGA = NULL;
    }


/*    
    // DELETE THREAD PARAM STRUCT
    delete pThreadParam;
/**/
    // SET ACTIVE THREAD PTR TO NULL
    pSensorSim->m_pActualThread = NULL;
    
	// Send message that this thread has ended
    pSensorSim->PostMessage(WM_THREAD_ENDED);

	return status;
}

void CKeyInfectTab::OnBnClickedGaScript()
{
#ifdef PERFTIME
    DeleteFile("perfTime.txt");
    pSensorSim->ClearPerformance();
#endif

    int                 status = STAT_OK;

    if (pSensorSim->m_sensorEnv.m_pActualDeployment->sensorsDeployed) {
        srand((unsigned int) time(NULL));
        UpdateData(TRUE);
        
        //
        // PREPARE SETTINGS
        //
        GetGASettings(pSensorSim->m_pGAStrategy);

        // SAVE CONFIGURATION SCRIPT
        pSensorSimDlg->GetBasicSettings(&(pSensorSim->m_sensorEnv.m_basicSettings), FALSE);

		// Reset value signalizing population loaded from file (if any)
		 pSensorSim->m_sensorEnv.m_lastLoadedGenom = -1;

		// SET TEST TYPE FOR THE CASE OF REMOTE EXECUTION
		pSensorSim->m_sensorEnv.m_basicSettings.testType |= FLAG_TESTTYPE_EAPROTOCOLSEARCH;
		
		CString cfgFile; 
        cfgFile.Format("%s\\!cfgScript.ini", pSensorSim->m_basePath);
        status = pSensorSim->m_sensorEnv.SaveConfigScript(cfgFile, &(pSensorSim->m_sensorEnv.m_basicSettings));

	    if (pSensorSim->m_sensorEnv.m_basicSettings.remoteConfig.actualRemoteHost == HOST_ACTUAL) {
			// INTERRUPT PREVIOUS THREAD
			if (pSensorSim->m_pActualThread != NULL) TerminateThread(pSensorSim->m_pActualThread->m_hThread, 0);

			// RESET SOFT FLAG FOR STOPPING CURRENT FLAG
			pSensorSim->m_stopThreadSoft = FALSE;

			// RUN WORKER THREAD FOR EXECUTION
			pSensorSim->m_pActualThread = AfxBeginThread(CKeyInfectTab::RunGAS, NULL, THREAD_PRIORITY_LOWEST); 
		}
		else {
    		// RUN ON SELECTED REMOTE COMPUTER
			pSensorSim->RunRemoteExecution(pSensorSim->m_sensorEnv.m_basicSettings.remoteConfig.actualRemoteHost, cfgFile, "XX2");   
		}
    }
    else {
        pSensorSim->Log_InsertString("Network not deployed!", FALSE); 
    }

#ifdef PERFTIME    
    pSensorSim->ShowPerformance();
#endif
}

void CKeyInfectTab::OnBnClickedExecuteFromtext()
{
    pSensorSim->ClearPerformance();

    int     status = STAT_OK;
    DWORD   maxInstruct = 1000;
    GAS_ELEMENT_TYPE    protocol[1000 * GAS_INSLENGTH];
    CString message;
    CString value;
    GAS_ELEMENT_TYPE*   prunnedProtocol = NULL;

    UpdateData(TRUE);
    
    // GET SETTINGS
    GetGASettings(pSensorSim->m_pGAStrategy);

    // SAVE CONFIGURATION SCRIPT
    pSensorSimDlg->GetBasicSettings(&(pSensorSim->m_sensorEnv.m_basicSettings));
    
    // PARSE PROTOCOL FROM TEXT 
    if ((status = pSensorSim->m_sensorEnv.GAS_ParseProtocol(m_textProtocol, protocol, &maxInstruct, &(pSensorSim->m_pGAStrategy->maxParties), pSensorSim->m_pGAStrategy)) == STAT_OK) {
        value.Format("Instruction parsed: %d, parties found: %d", maxInstruct, pSensorSim->m_pGAStrategy->maxParties);
        pSensorSim->Log_InsertString(value); 

        pSensorSim->m_pGAStrategy->numRepeat = atoi(m_amplifRepeat);
        memset(pSensorSim->m_pGAStrategy->stratString, 0, pSensorSim->m_pGAStrategy->stratStringSize * sizeof(GAS_ELEMENT_TYPE)); 
        // COPY AND EXECUTE
		int fncSlots = (pSensorSim->m_pGAStrategy->useSubFunct) ? pSensorSim->m_pGAStrategy->sfncSlots : 0;
        for (int i = 0; i < (maxInstruct + fncSlots); i++) {
			DWORD insBase = i * GAS_INSLENGTH;
			for (int insOffs = 0; insOffs < GAS_INSLENGTH; insOffs++) pSensorSim->m_pGAStrategy->stratString[insBase + insOffs] = protocol[insBase + insOffs]; 
        }
        for (int slot = 0; slot < (maxInstruct + fncSlots); slot++) {
            pSensorSim->m_pGAStrategy->toString(slot, &message, pSensorSim->m_pGAStrategy->protocolTypeFlags);
            value.Format("  %2d:", slot);
            value += message;
            pSensorSim->Log_InsertString(value, FALSE); 
        }
     
        // EVALUATE FITNESS
        pSensorSim->m_pGAStrategy->fitness = 0;
		GA_PROTOCOL_STATS stats;
        if ((status = pSensorSim->m_sensorEnv.GAS_ExecuteStrategy(pSensorSim->m_pGAStrategy, &stats)) == STAT_OK) {
            value.Format("Fitness: %f (%0.4f%% secured, %0.2f messages, %d/%d SND ins)", 
				pSensorSim->m_pGAStrategy->fitness, 
				stats.getSecuredRatio()*100, 
				stats.getAverageMessages(),
				stats.insCount[GAS_INS_SEND],
				stats.insTotalCount
			); 
			pSensorSim->Log_InsertString(value); 
        }
        else {
            ASSERT(FALSE);
            value.Format("GAS_ExecuteStrategy fail with %s (%d)", ERROR_TO_STRING(status), status);
            pSensorSim->Log_InsertString(value); 
        }    
     
        if (m_prunneResults) {
			GAS_ELEMENT_TYPE* prunnedGenom = new GAS_ELEMENT_TYPE[(maxInstruct + fncSlots) * GAS_INSLENGTH];
			memset(prunnedGenom, 0, (maxInstruct + fncSlots) * GAS_INSLENGTH * sizeof(GAS_ELEMENT_TYPE));
    
			float*  insFitnessGain = new float[maxInstruct + fncSlots]; 
			memset(insFitnessGain, 0, (maxInstruct + fncSlots) * sizeof(float));
                
			status = pSensorSim->m_sensorEnv.GAS_PruneProtocol(protocol, prunnedGenom, maxInstruct, pSensorSim->m_pGAStrategy->fitness, 3, insFitnessGain, pSensorSim->m_pGAStrategy->sfncSlots);
        
			delete[] insFitnessGain;
			delete[] prunnedGenom;
        }
    }
    else {
        ASSERT(FALSE);
    }    

    pSensorSim->ShowPerformance();
}

void CKeyInfectTab::LoadPopulationFromfile(CString path){
	int         status = STAT_OK;
    CString     message;

    UpdateData(TRUE);

    // GET SETTINGS
    GetGASettings(pSensorSim->m_pGAStrategy);

    // SAVE CONFIGURATION SCRIPT
    pSensorSimDlg->GetBasicSettings(&(pSensorSim->m_sensorEnv.m_basicSettings));

	if ((status = pSensorSim->m_sensorEnv.GAS_LoadFromFile(path, pSensorSim->m_pGAStrategy)) == STAT_OK) {
		// UPDATE DIALOG BY LOADED SETTINGS
		UpdateData(TRUE);
            
		m_amplifRepeat.Format("%d", pSensorSim->m_pGAStrategy->numRepeat);
		m_prunneResults = pSensorSim->m_pGAStrategy->prunneResults;
		m_amplifRepeat.Format("%d", pSensorSim->m_pGAStrategy->numRepeat);
		m_numParties.Format("%d", pSensorSim->m_pGAStrategy->maxParties);
		m_nodeMemorySize.Format("%d", pSensorSim->m_pGAStrategy->partyMemorySize);
		m_maxInstr.Format("%d", pSensorSim->m_pGAStrategy->maxInstruct);
		m_sfncSlots.Format("%d", pSensorSim->m_pGAStrategy->sfncSlots);
		m_sfncSize.Format("%d", pSensorSim->m_pGAStrategy->sfncSize);
		m_UseSfnc = pSensorSim->m_pGAStrategy->useSubFunct;
		m_mutationProb.Format("%.2f", pSensorSim->m_pGAStrategy->pMutt);
		m_crossOverProb.Format("%.2f", pSensorSim->m_pGAStrategy->pCross);
		m_populSize.Format("%d", pSensorSim->m_pGAStrategy->popSize);
		m_numGener.Format("%d", pSensorSim->m_pGAStrategy->nGeners);
            
		UpdateData(FALSE);
            
		message.Format("Load population '%s' OK", path);
		LOG_INSERTSTRING(message);
 	}
	else {
		message.Format("Load population '%s' failed (error %d(%s))", path, status, ERROR_TO_STRING(status));
		LOG_INSERTSTRING(message); 
	}
}

void CKeyInfectTab::OnBnClickedRestartFromfile()
{
    CFileDialog fileDialog(TRUE);

    // BROWSE FOR PATH
    if (fileDialog.DoModal() == IDOK) {
        LoadPopulationFromfile(fileDialog.GetPathName());
    }
}

void CKeyInfectTab::OnBnClickedWhitePattern()
{
	// SET TEST TYPE FOR THE CASE OF REMOTE EXECUTION
	UpdateData(TRUE);
    // OBTAIN BASIC GA SETTINGS
    BASIC_INIT_DATA basicSettings;
    pSensorSimDlg->GetBasicSettings(&basicSettings);
	// SET TEST TYPE FOR THE CASE OF REMOTE EXECUTION
	basicSettings.testType |= FLAG_TESTTYPE_EAWHITEPATTERNSEARCH;
	// SAVE CONFIGURATION SCRIPT
	CString	cfgScriptPath;
	cfgScriptPath.Format("%s\\!cfgScript.ini", pSensorSim->m_basePath);
    int status = pSensorSim->m_sensorEnv.SaveConfigScript(cfgScriptPath, &basicSettings);
	
	if (basicSettings.remoteConfig.actualRemoteHost == HOST_ACTUAL) {
	    EvolveDeployPattern(FALSE);    
    }
    else {
    	// RUN ON SELECTED REMOTE COMPUTER
	    pSensorSim->RunRemoteExecution(basicSettings.remoteConfig.actualRemoteHost, cfgScriptPath, "XX2");   
	}    
}
void CKeyInfectTab::OnBnClickedBlackPattern()
{   
	// SET TEST TYPE FOR THE CASE OF REMOTE EXECUTION
	UpdateData(TRUE);
    // OBTAIN BASIC GA SETTINGS
    BASIC_INIT_DATA basicSettings;
    pSensorSimDlg->GetBasicSettings(&basicSettings);
	// SET TEST TYPE FOR THE CASE OF REMOTE EXECUTION
	basicSettings.testType |= FLAG_TESTTYPE_EABLACKPATTERNSEARCH;
	// SAVE CONFIGURATION SCRIPT
	CString	cfgScriptPath;
	cfgScriptPath.Format("%s\\!cfgScript.ini", pSensorSim->m_basePath);
    int status = pSensorSim->m_sensorEnv.SaveConfigScript(cfgScriptPath, &basicSettings);
	
	if (basicSettings.remoteConfig.actualRemoteHost == HOST_ACTUAL) {
	    EvolveDeployPattern(TRUE);    
    }
    else {
    	// RUN ON SELECTED REMOTE COMPUTER
	    pSensorSim->RunRemoteExecution(basicSettings.remoteConfig.actualRemoteHost, cfgScriptPath, "XX2");   
	}    
}

int CKeyInfectTab::EvolveDeployPattern(BOOL bBlackPattern) {
    int         status = STAT_OK;
    DWORD       maxInstruct = 1000;
    GAS_ELEMENT_TYPE        protocol[1000 * GAS_INSLENGTH];
    CString     message;
    CString     value;

    if (pSensorSim->m_sensorEnv.m_pActualDeployment->sensorsDeployed) {
        srand((unsigned int) time(NULL));
        UpdateData(TRUE);
        
        GetGASettings(pSensorSim->m_pGAStrategy);

        pSensorSimDlg->GetBasicSettings(&(pSensorSim->m_sensorEnv.m_basicSettings));
        // SAVE CONFIGURATION SCRIPT
        CString cfgFile; 
        cfgFile.Format("%s\\!cfgScript.ini", pSensorSim->m_basePath);
        status = pSensorSim->m_sensorEnv.SaveConfigScript(cfgFile, &(pSensorSim->m_sensorEnv.m_basicSettings));
        
        // PARSE PROTOCOL FROM TEXT 
        if ((status = pSensorSim->m_sensorEnv.GAS_ParseProtocol(m_textProtocol, protocol, &maxInstruct, &(pSensorSim->m_pGAStrategy->maxParties))) == STAT_OK) {
            value.Format("Instruction parsed: %d, parties found: %d", maxInstruct, pSensorSim->m_pGAStrategy->maxParties);
            pSensorSim->Log_InsertString(value); 

            // PREPARE PROTOCOL, FOT THAT BLACK PATTERN WILL BE SEARCHED AGAINST  
            pSensorSim->m_pGAStrategy->maxInstruct = maxInstruct;
            pSensorSim->m_pGAStrategy->numRepeat = atoi(m_amplifRepeat);
            memset(pSensorSim->m_pGAStrategy->stratString, 0, pSensorSim->m_pGAStrategy->stratStringSize * sizeof(GAS_ELEMENT_TYPE)); 
            // COPY AND EXECUTE
            for (int i = 0; i < maxInstruct; i++) {
				DWORD insBase = i * GAS_INSLENGTH;
				for (int insOffs = 0; insOffs < GAS_INSLENGTH; insOffs++) pSensorSim->m_pGAStrategy->stratString[insBase + insOffs] = protocol[insBase + insOffs]; 
            }
            for (int slot = 0; slot < pSensorSim->m_pGAStrategy->maxInstruct; slot++) {
                pSensorSim->m_pGAStrategy->toString(slot, &message);
                value.Format("  %2d:", slot);
                value += message;
                pSensorSim->Log_InsertString(value, FALSE); 
            }
         
         
            //
            //  PREPARE EVOLUTION OF POSITION PATTERN
            //
            
            //
            // ALLOCATE GENOM AND GA ALGORITHM, ONLY IF NOT PREPARED BEFORE (E.G. LOADED FROM FILE)
            //
            GARandomSeed();
            BOOL    bNewPopulation = FALSE;
            if (pSensorSim->m_pGAStrategy->pGA == NULL) {
                int nodesPerCell = 0;
                if (bBlackPattern) { nodesPerCell = (int) pSensorSim->m_sensorEnv.m_basicSettings.blackNum / pow((float) pSensorSim->m_pGAStrategy->blackDeployPattern.numCellPerAxis, 2); }
                else { nodesPerCell = (int) pSensorSim->m_sensorEnv.m_basicSettings.whiteNum / pow((float) pSensorSim->m_pGAStrategy->whiteDeployPattern.numCellPerAxis, 2); }
                
                if (bBlackPattern) { 
                    pSensorSim->m_pGAStrategy->pGenom = new GA1DArrayGenome<int> (nodesPerCell * 2, CSensorEnv::GABP_fitness);
                }
                else { 
                    pSensorSim->m_pGAStrategy->pGenom = new GA1DArrayGenome<int> (nodesPerCell * 2, CSensorEnv::GAWP_fitness);
                }
                  
                
                pSensorSim->m_pGAStrategy->pGenom->initializer(CSensorEnv::GABP_initializer_random); 
                pSensorSim->m_pGAStrategy->pGenom->mutator(CSensorEnv::GABP_mutator); 
                pSensorSim->m_pGAStrategy->pGenom->crossover(CSensorEnv::GABP_crossover); 
                
                pSensorSim->m_pGAStrategy->pGA = new GASteadyStateGA(*(pSensorSim->m_pGAStrategy->pGenom));
                // FLAG AS NEW POPULATION
                bNewPopulation = TRUE;
            }        
                
            pSensorSim->m_pGAStrategy->pGA->nReplacement(2 * (pSensorSim->m_pGAStrategy->popSize / 3));  
            pSensorSim->m_pGAStrategy->pGA->populationSize(pSensorSim->m_pGAStrategy->popSize); 
            pSensorSim->m_pGAStrategy->pGA->nGenerations(pSensorSim->m_pGAStrategy->nGeners);
            pSensorSim->m_pGAStrategy->pGA->pCrossover(pSensorSim->m_pGAStrategy->pCross);
            pSensorSim->m_pGAStrategy->pGA->pMutation(pSensorSim->m_pGAStrategy->pMutt); 

            // INITIALIZE POPULATION
            if (bNewPopulation) {
                pSensorSim->m_pGAStrategy->pGA->initialize();
            }

            if (status == STAT_OK) {
				GABP_THREAD_PARAM*      pThreadParam = new GABP_THREAD_PARAM;
				pThreadParam->pGAStrategy = pSensorSim->m_pGAStrategy;
				pThreadParam->bBlackPattern = bBlackPattern;
			    
				// SAVE CONFIGURATION SCRIPT
				CString	cfgScriptPath;
				cfgScriptPath.Format("%s\\!cfgScript.ini", pSensorSim->m_basePath);
				status = pSensorSim->m_sensorEnv.SaveConfigScript(cfgScriptPath, &(pSensorSim->m_sensorEnv.m_basicSettings));

				// INTERRUPT PREVIOUS THREAD
				if (pSensorSim->m_pActualThread != NULL) TerminateThread(pSensorSim->m_pActualThread->m_hThread, 0);

				// RESET SOFT FLAG FOR STOPPING CURRENT FLAG
				pSensorSim->m_stopThreadSoft = FALSE;

				// RUN WORKER THREAD FOR EXECUTION
				pSensorSim->m_pActualThread = AfxBeginThread(CSensorEnv::ExecuteGABPEvolve, pThreadParam, THREAD_PRIORITY_LOWEST); 
            }
/*            
            //  RELEASE STRUCTS
            if (pSensorSim->m_pGAStrategy->pGenom) {
                delete pSensorSim->m_pGAStrategy->pGenom;
                pSensorSim->m_pGAStrategy->pGenom = NULL;
            }       
            if (pSensorSim->m_pGAStrategy->pGA) {
                delete pSensorSim->m_pGAStrategy->pGA;
                pSensorSim->m_pGAStrategy->pGA = NULL;
            }
/**/
        }        
    }
    else {
        pSensorSim->Log_InsertString("Network not deployed!", FALSE); 
    }
    
    return status;
}


void CKeyInfectTab::OnBnClickedBlackwhitePatternEvolution()
{
    int         status = STAT_OK;
    DWORD       maxInstruct = 1000;
    GAS_ELEMENT_TYPE        protocol[1000 * GAS_INSLENGTH];
    CString     message;
    CString     value;
    GA_STRATEGY whiteStrategy;
    GA_STRATEGY blackStrategy;
    
    CSensorEnv::GAS_AllocateDefaultStrategyStructs(&whiteStrategy);
    CSensorEnv::GAS_AllocateDefaultStrategyStructs(&blackStrategy);

    if (pSensorSim->m_sensorEnv.m_pActualDeployment->sensorsDeployed) {
        srand((unsigned int) time(NULL));
        UpdateData(TRUE);
        
        GetGASettings(&whiteStrategy);
        GetGASettings(&blackStrategy);

        pSensorSimDlg->GetBasicSettings(&(pSensorSim->m_sensorEnv.m_basicSettings));
        // SAVE CONFIGURATION SCRIPT
        CString cfgFile; 
        cfgFile.Format("%s\\!cfgScript.ini", pSensorSim->m_basePath);
        status = pSensorSim->m_sensorEnv.SaveConfigScript(cfgFile, &(pSensorSim->m_sensorEnv.m_basicSettings));
        
        // PARSE PROTOCOL FROM TEXT 
        DWORD maxParties = 0;
        if ((status = pSensorSim->m_sensorEnv.GAS_ParseProtocol(m_textProtocol, protocol, &maxInstruct, &maxParties)) == STAT_OK) {
            whiteStrategy.maxParties = blackStrategy.maxParties = maxParties;
            value.Format("Instruction parsed: %d, parties found: %d", maxInstruct, whiteStrategy.maxParties);
            pSensorSim->Log_InsertString(value); 

            // PREPARE PROTOCOL, FOR THAT BLACK PATTERN WILL BE SEARCHED AGAINST  
            whiteStrategy.maxInstruct = blackStrategy.maxInstruct = maxInstruct;
            whiteStrategy.numRepeat = blackStrategy.numRepeat = atoi(m_amplifRepeat);
            memset(whiteStrategy.stratString, 0, whiteStrategy.stratStringSize * sizeof(GAS_ELEMENT_TYPE)); 
            memset(blackStrategy.stratString, 0, blackStrategy.stratStringSize * sizeof(GAS_ELEMENT_TYPE)); 
            // COPY TO STRATEGY STRINGS
            for (int i = 0; i < maxInstruct; i++) {
				DWORD insBase = i * GAS_INSLENGTH;
				for (int insOffs = 0; insOffs < GAS_INSLENGTH; insOffs++) whiteStrategy.stratString[insBase + insOffs] = blackStrategy.stratString[insBase + insOffs] = protocol[insBase + insOffs]; 
            }
            for (int slot = 0; slot < whiteStrategy.maxInstruct; slot++) {
                whiteStrategy.toString(slot, &message);
                value.Format("  %2d:", slot);
                value += message;
                pSensorSim->Log_InsertString(value, FALSE); 
            }
         
         
            //
            // ALLOCATE GENOM AND GA ALGORITHM, DIFFERENT FROM WHITE AND BLACK POPULATION
            //
            GARandomSeed();
            int nodesPerCell = 0;
            nodesPerCell = (int) pSensorSim->m_sensorEnv.m_basicSettings.blackNum / pow((float) blackStrategy.blackDeployPattern.numCellPerAxis, 2); 
            blackStrategy.pGenom = new GA1DArrayGenome<int> (nodesPerCell * 2, CSensorEnv::GABP_fitness);
            nodesPerCell = (int) pSensorSim->m_sensorEnv.m_basicSettings.whiteNum / pow((float) whiteStrategy.blackDeployPattern.numCellPerAxis, 2); 
            whiteStrategy.pGenom = new GA1DArrayGenome<int> (nodesPerCell * 2, CSensorEnv::GAWP_fitness);
                
            blackStrategy.pGenom->initializer(CSensorEnv::GABP_initializer_random); 
            whiteStrategy.pGenom->initializer(CSensorEnv::GABP_initializer_random); 
            blackStrategy.pGenom->mutator(CSensorEnv::GABP_mutator); 
            whiteStrategy.pGenom->mutator(CSensorEnv::GABP_mutator); 
            blackStrategy.pGenom->crossover(CSensorEnv::GABP_crossover); 
            whiteStrategy.pGenom->crossover(CSensorEnv::GABP_crossover); 

            whiteStrategy.pGA = new GASteadyStateGA(*(whiteStrategy.pGenom));
            blackStrategy.pGA = new GASteadyStateGA(*(blackStrategy.pGenom));

            //blackStrategy.pGA->nReplacement(2 * (blackStrategy.popSize / 3)); 
            //whiteStrategy.pGA->nReplacement(2 * (whiteStrategy.popSize / 3)); 
            blackStrategy.pGA->nReplacement(blackStrategy.popSize); 
            whiteStrategy.pGA->nReplacement(whiteStrategy.popSize); 
            blackStrategy.pGA->populationSize(blackStrategy.popSize); 
            whiteStrategy.pGA->populationSize(whiteStrategy.popSize); 
            blackStrategy.pGA->nGenerations(whiteStrategy.nGeners); 
            whiteStrategy.pGA->nGenerations(blackStrategy.nGeners); 
            blackStrategy.pGA->pCrossover(whiteStrategy.pCross); 
            whiteStrategy.pGA->pCrossover(blackStrategy.pCross); 
            blackStrategy.pGA->pMutation(whiteStrategy.pMutt); 
            whiteStrategy.pGA->pMutation(blackStrategy.pMutt); 

            //
            // INITIALIZE BOTH POPULATIONS
            //
            // SAVE OROGINAL STRATEGY POINTER
            GA_STRATEGY* pOldStrategy = pSensorSim->m_pGAStrategy;
            // SWITCH GLOBAL STRUCT TO WHITE STRATEGY 
            pSensorSim->m_pGAStrategy = &whiteStrategy;
            whiteStrategy.pGA->initialize();
            // SWITCH GLOBAL STRUCT TO BLACK STRATEGY 
            pSensorSim->m_pGAStrategy = &blackStrategy;
            blackStrategy.pGA->initialize();
            // RESTORE ORIGINAL STRATEGY POINTER
            pSensorSim->m_pGAStrategy = pOldStrategy;

            if (status == STAT_OK) {
                status = pSensorSim->m_sensorEnv.GABWP_Evolve(&whiteStrategy, &blackStrategy);
            }
        }        
    }
    else {
        pSensorSim->Log_InsertString("Network not deployed!", FALSE); 
    }
    
    whiteStrategy.release();
    blackStrategy.release();
}

void CKeyInfectTab::OnBnClickedLoadBlackPattern()
{
    LoadAndDeployByPattern(FLAG_SENSOR_BLACK);
}

void CKeyInfectTab::OnBnClickedLoadWhitePattern()
{
    LoadAndDeployByPattern(FLAG_SENSOR_WHITE);
}

int CKeyInfectTab::LoadAndDeployByPattern(DWORD flags) {
    // LOAD NODE'S PATTERN FROM TEXT AND DEPLOY NODES IN THAT WAY
    int         status = STAT_OK;
    CString     message;
    CString     value;
    NODES_DEPLOY_PATTERN*   pPattern;

    if (pSensorSim->m_sensorEnv.m_pActualDeployment->sensorsDeployed) {
        srand((unsigned int) time(NULL));
        UpdateData(TRUE);
        
        GetGASettings(pSensorSim->m_pGAStrategy);
        pSensorSimDlg->GetBasicSettings(&(pSensorSim->m_sensorEnv.m_basicSettings));

        if (flags & FLAG_SENSOR_BLACK) {
            pPattern = &(pSensorSim->m_pGAStrategy->blackDeployPattern);
        }
        if (flags & FLAG_SENSOR_WHITE) {
            pPattern = &(pSensorSim->m_pGAStrategy->whiteDeployPattern);
        }
        
        // PARSE PATTERN FROM TEXT 
        DWORD maxParties = 0;
        if ((status = pSensorSim->m_sensorEnv.GADP_ParsePattern(m_textProtocol, pPattern)) == STAT_OK) {
	        // #ALL DEPLOYMENTS
	        for (int dep = 0; dep < pSensorSim->m_sensorEnv.m_basicSettings.numDeployments; dep++) {
 	            // set actual deployment
	            pSensorSim->m_sensorEnv.m_pActualDeployment = pSensorSim->m_sensorEnv.m_deploymentList[dep];
            
                // REMOVE PREVIOUS NODES AND DEPLOY AGAIN
                status = pSensorSim->m_sensorEnv.RemoveDeployedNodes(flags);
                
                // COMPUTE NUMBER TOTAL OF NODES, BASED ON PATTERN SIZE AND NUMBER OF CELLS
                int totalCells = pow((float) pPattern->numCellPerAxis, 2);
                int totalNodes = totalCells * pPattern->numNodes;
                if (flags & FLAG_SENSOR_BLACK) {
                    pSensorSim->m_sensorEnv.m_basicSettings.blackNum = totalNodes;
                }
                if (flags & FLAG_SENSOR_WHITE) {
                    pSensorSim->m_sensorEnv.m_basicSettings.whiteNum = totalNodes;
                }
                message.Format("Total cells: %d, Total nodes deployed: %d", totalCells, totalNodes);
                pSensorSim->Log_InsertString(message); 
                
                // DEPLOY NEW NODES ACCORDING TO PATTERN
                status = pSensorSim->m_sensorEnv.DeployNodesByPattern(&(pSensorSim->m_sensorEnv.m_basicSettings), pPattern, flags);
                
                
                // SHOW LOADED PATTERN
                CSensorEnv::GABP_FormatAsciiPattern(pPattern, &value, TRUE); 
                pSensorSim->Log_InsertString(value, FALSE, FALSE); 
                CSensorEnv::GABP_FormatAsciiPattern(pPattern, &value, FALSE); 
                pSensorSim->Log_InsertToFile(pSensorSim->m_logFile, value); 
            }
           
	        // set again first deployment struct
	        pSensorSim->m_sensorEnv.m_pActualDeployment = pSensorSim->m_sensorEnv.m_deploymentList[0];
        }
    }
    else {
        pSensorSim->Log_InsertString("Network not deployed!", FALSE); 
    }
    
    return status;
}




void CKeyInfectTab::OnBnClickedFindInsDependency()
{
    int     status = STAT_OK;
    DWORD   maxInstruct = 1000;
    GAS_ELEMENT_TYPE    protocol[1000 * GAS_INSLENGTH];
    CString message;
    CString value;
    GAS_ELEMENT_TYPE*   prunnedProtocol = NULL;
	
    UpdateData(TRUE);
    
    // GET SETTINGS
    GetGASettings(pSensorSim->m_pGAStrategy);

    // SAVE CONFIGURATION SCRIPT
    pSensorSimDlg->GetBasicSettings(&(pSensorSim->m_sensorEnv.m_basicSettings));
    
    // PARSE PROTOCOL FROM TEXT 
    if ((status = pSensorSim->m_sensorEnv.GAS_ParseProtocol(m_textProtocol, protocol, &maxInstruct, &(pSensorSim->m_pGAStrategy->maxParties), pSensorSim->m_pGAStrategy)) == STAT_OK) {
        value.Format("Instruction parsed: %d, parties found: %d", maxInstruct, pSensorSim->m_pGAStrategy->maxParties);
        pSensorSim->Log_InsertString(value); 

        pSensorSim->m_pGAStrategy->numRepeat = atoi(m_amplifRepeat);
        memset(pSensorSim->m_pGAStrategy->stratString, 0, pSensorSim->m_pGAStrategy->stratStringSize * sizeof(GAS_ELEMENT_TYPE)); 
        // COPY 
		int fncSlots = (pSensorSim->m_pGAStrategy->useSubFunct) ? pSensorSim->m_pGAStrategy->sfncSlots : 0;
        for (int i = 0; i < (maxInstruct + fncSlots); i++) {
			DWORD insBase = i * GAS_INSLENGTH;
			for (int insOffs = 0; insOffs < GAS_INSLENGTH; insOffs++)  pSensorSim->m_pGAStrategy->stratString[insBase + insOffs] = protocol[insBase + insOffs]; 
        }
        for (int slot = 0; slot < (maxInstruct + fncSlots); slot++) {
            pSensorSim->m_pGAStrategy->toString(slot, &message, pSensorSim->m_pGAStrategy->protocolTypeFlags);
            value.Format("  %2d:", slot);
            value += message;
            pSensorSim->Log_InsertString(value, FALSE); 
        }
        // ORIGINAL FITNESS
        pSensorSim->m_pGAStrategy->fitness = 0;
        status = pSensorSim->m_sensorEnv.GAS_ExecuteStrategy(pSensorSim->m_pGAStrategy);
        message.Format("Original fitness: %f", pSensorSim->m_pGAStrategy->fitness);
        pSensorSim->Log_InsertString(message);
     
        //
        // PRUNE LOADED PROTOCOL
        //
        #define MAX_ELEMENTS    500
        GAS_ELEMENT_TYPE    originalProtocol[MAX_ELEMENTS * GAS_INSLENGTH];
        GAS_ELEMENT_TYPE    prunnedProtocol[MAX_ELEMENTS * GAS_INSLENGTH];
        int                 highestValidIns = 0;
        memset(originalProtocol, 0, MAX_ELEMENTS * GAS_INSLENGTH * sizeof(GAS_ELEMENT_TYPE));
        memset(prunnedProtocol, 0, MAX_ELEMENTS * GAS_INSLENGTH * sizeof(GAS_ELEMENT_TYPE));
        float  insFitnessGain[MAX_ELEMENTS];
        float  gainMatrix[MAX_ELEMENTS][MAX_ELEMENTS]; 
        float  gainMatrixFraction[MAX_ELEMENTS][MAX_ELEMENTS]; 
        memset(insFitnessGain, 0, MAX_ELEMENTS * sizeof(float));
        memset(gainMatrix, 0, MAX_ELEMENTS * MAX_ELEMENTS * sizeof(float));
        memset(gainMatrixFraction, 0, MAX_ELEMENTS * MAX_ELEMENTS * sizeof(float));
        pSensorSim->m_pGAStrategy->fitness = 0;
        status = pSensorSim->m_sensorEnv.GAS_ExecuteStrategy(pSensorSim->m_pGAStrategy);
        status = pSensorSim->m_sensorEnv.GAS_PruneProtocol(pSensorSim->m_pGAStrategy->stratString, originalProtocol, pSensorSim->m_pGAStrategy->maxInstruct, pSensorSim->m_pGAStrategy->fitness, 3, insFitnessGain, pSensorSim->m_pGAStrategy->sfncSlots);
        
        memset(pSensorSim->m_pGAStrategy->stratString, 0, pSensorSim->m_pGAStrategy->stratStringSize);
        memcpy(pSensorSim->m_pGAStrategy->stratString, originalProtocol, sizeof(originalProtocol));
		        
        // 
        // REMOVE INSTRUCTION FROM PRUNNED PROTOCOL AND OBSERVE FITNESS DECREASE OF EACH OTHER INSTRUCTION   
        //
        float  insFitnessGain_help[MAX_ELEMENTS];
        memset(insFitnessGain_help, 0, MAX_ELEMENTS * sizeof(float));
     
        for (int slot = 0; slot < pSensorSim->m_pGAStrategy->maxInstruct; slot++) {
            if (originalProtocol[slot * GAS_INSLENGTH + GAS_OFFSET_INSTAT] == GAS_INSACTIVE) {
                // TEMPORALY DISABLE INSTRUCTION
                GAS_ELEMENT_TYPE    insType = originalProtocol[slot * GAS_INSLENGTH + GAS_OFFSET_INSTYPE];
                originalProtocol[slot * GAS_INSLENGTH + GAS_OFFSET_INSTYPE] = GAS_INS_NOP;
                originalProtocol[slot * GAS_INSLENGTH + GAS_OFFSET_INSTAT] = GAS_INSINACTIVE;
                
                memset(insFitnessGain_help, 0, MAX_ELEMENTS * sizeof(float));
                
                // PRUNE PROTOCOL AND OBTAIN FITNESS 
                memset(pSensorSim->m_pGAStrategy->stratString, 0, pSensorSim->m_pGAStrategy->stratStringSize);
                memcpy(pSensorSim->m_pGAStrategy->stratString, originalProtocol, sizeof(originalProtocol));
                pSensorSim->m_pGAStrategy->fitness = 0;
                status = pSensorSim->m_sensorEnv.GAS_ExecuteStrategy(pSensorSim->m_pGAStrategy);
                message.Format("\n### Fitness after removing instruction '%d': %f", slot, pSensorSim->m_pGAStrategy->fitness);
                pSensorSim->Log_InsertString(message);

                memset(pSensorSim->m_pGAStrategy->stratString, 0, pSensorSim->m_pGAStrategy->stratStringSize);
                memcpy(pSensorSim->m_pGAStrategy->stratString, originalProtocol, sizeof(originalProtocol));
                memset(prunnedProtocol, 0, sizeof(prunnedProtocol));
                status = pSensorSim->m_sensorEnv.GAS_PruneProtocol(pSensorSim->m_pGAStrategy->stratString, prunnedProtocol, pSensorSim->m_pGAStrategy->maxInstruct, pSensorSim->m_pGAStrategy->fitness, 3, insFitnessGain_help, pSensorSim->m_pGAStrategy->sfncSlots);

                memset(pSensorSim->m_pGAStrategy->stratString, 0, pSensorSim->m_pGAStrategy->stratStringSize);
                memcpy(pSensorSim->m_pGAStrategy->stratString, prunnedProtocol, sizeof(prunnedProtocol));
                
                // COMPARE FITNESS DECREASE FOR EACH INSTRUCTION
                for (int i = 0; i < pSensorSim->m_pGAStrategy->maxInstruct; i++) {
                    // IF PRINTING GROUP ORIENTED PROTOCOL, THEN SEPARATE SUBFUNCTION SLOTS
                    if ((i % pSensorSim->m_pGAStrategy->sfncSize == 0) && (pSensorSim->m_pGAStrategy->protocolTypeFlags & FLAG_PROTOCOL_GROUPORIENTED)) {
                        value.Format("FNC:%1d ---", i / pSensorSim->m_pGAStrategy->sfncSize);
                        pSensorSim->Log_InsertString(value, FALSE); 
                    }
                    // PRINT ACTIVE INSTRUCTIONS
                    if (pSensorSim->m_pGAStrategy->stratString[i * GAS_INSLENGTH + GAS_OFFSET_INSTAT] == GAS_INSACTIVE) {
                        pSensorSim->m_pGAStrategy->toString(i, &message, pSensorSim->m_pGAStrategy->protocolTypeFlags);
                        value.Format("  [%.3f %.3f (%.3f)] %2d: ", insFitnessGain[i], insFitnessGain_help[i], insFitnessGain_help[i] - insFitnessGain[i], i);
                        value += message;
                        pSensorSim->Log_InsertString(value, FALSE); 

                        // STORE MATRIX RESULTS
                        gainMatrix[slot][i] = insFitnessGain_help[i] - insFitnessGain[i];
                        gainMatrixFraction[slot][i] = (insFitnessGain[i] != 0) ? insFitnessGain_help[i] - insFitnessGain[i] / insFitnessGain[i] : 0;
                    }
                    else {
                        // INSTRUCTION IS NOT USED, REMOVE WHOLE ORIGINAL GAIN 
                        gainMatrix[slot][i] = - insFitnessGain[i];
                        gainMatrixFraction[slot][i] = -1;
                    }
                    
                    ASSERT(abs(gainMatrixFraction[slot][i]) <= 1);
                }
                
                // ENABLE DISABLED INSTRUCTION 
                originalProtocol[slot * GAS_INSLENGTH + GAS_OFFSET_INSTYPE] = insType;
                originalProtocol[slot * GAS_INSLENGTH + GAS_OFFSET_INSTAT] = GAS_INSACTIVE;
            }
        }
        
        // PRINT MATRIX RESULTS
        CString     dependency = "";
        for (int slot = 0; slot <= highestValidIns; slot++) {
            value.Format("ins %d (%f): & ", slot, insFitnessGain[slot]);
            dependency += value;

            if (originalProtocol[slot * GAS_INSLENGTH + GAS_OFFSET_INSTAT] == GAS_INSACTIVE) {
                value = "";
                CString line = "";
                for (int i = 0; i <= highestValidIns; i++) {
                    // value.Format("%.3f (%.3f) & ", gainMatrix[slot][i], gainMatrixFraction[slot][i]); 
                    value.Format("%.3f & ", gainMatrix[slot][i] ); 
                    line += value;
                    
                    if (gainMatrixFraction[slot][i] >= 0) { 
                        if (gainMatrixFraction[slot][i] == 0) dependency += "+In & ";
                        else if (gainMatrixFraction[slot][i] >= 1) dependency += "+Td & ";
                        else if (gainMatrixFraction[slot][i] > 0 && gainMatrixFraction[slot][i] < 0.33) dependency += "+d1 & ";
                        else if (gainMatrixFraction[slot][i] >= 0.33 && gainMatrixFraction[slot][i] < 0.66) dependency += "+d2 & ";
                        else if (gainMatrixFraction[slot][i] >= 0.66 && gainMatrixFraction[slot][i] < 1) dependency += "+d3 & ";
                    }
                    else {    
                        if (gainMatrixFraction[slot][i] <= -1) dependency += "-Td & ";
                        else if (abs(gainMatrixFraction[slot][i]) > 0 && abs(gainMatrixFraction[slot][i]) < 0.33) dependency += "-d1 & ";
                        else if (abs(gainMatrixFraction[slot][i]) >= 0.33 && abs(gainMatrixFraction[slot][i]) < 0.66) dependency += "-d2 & ";
                        else if (abs(gainMatrixFraction[slot][i]) >= 0.66 && abs(gainMatrixFraction[slot][i]) < 1) dependency += "-d3 & ";
                    }                    
                }
                if (line != "") {
                    value.Format("ins %d (%f): & ", slot, insFitnessGain[slot]);
                    line.Insert(0, value);
                    line += "\\\\ \\hline \n";
                    pSensorSim->Log_InsertString(line, FALSE); 
                }
            }
            dependency += "\\\\ \\hline \n";
        }        
        pSensorSim->Log_InsertString(dependency, FALSE); 
        
    }
    else {
        ASSERT(FALSE);
    }    
}

BOOL CKeyInfectTab::UpdateData(BOOL bSaveAndValidate){
	// WORKAROUND FOR EXECUTION IN BACKGROUND
	// ALLOW DATA UPDATE ONLY FROM MAIN THREAD
	if (AfxGetApp()->m_nThreadID == AfxGetThread()->m_nThreadID)
		return __super::UpdateData(bSaveAndValidate);
	else
		return FALSE;
}