#if !defined(AFX_KEYINFECTTAB_H__DF69980F_42B8_4E38_8E00_98D5C9DE3170__INCLUDED_)
#define AFX_KEYINFECTTAB_H__DF69980F_42B8_4E38_8E00_98D5C9DE3170__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// KeyInfectTab.h : header file
//
#include "resource.h"

/////////////////////////////////////////////////////////////////////////////
// CKeyInfectTab dialog

class CKeyInfectTab : public CDialog
{
// Construction
public:
	CKeyInfectTab(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CKeyInfectTab)
	enum { IDD = IDD_KEYINFECT_TAB };
	BOOL	m_rossAplifWhisper;
	BOOL	m_rossAplifMaxScream;
	BOOL	m_plainMaxScream;
	BOOL	m_basicWhisper;
	BOOL	m_mutualWhisper;
	CString	m_amplifRepeat;
	BOOL	m_danAmplifWhisper;
	BOOL	m_rossAmplifMutualWhisper;
	BOOL	m_danAmplifMutualWhisper;
	BOOL	m_useEGScheme;
	BOOL	m_useMMD;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CKeyInfectTab)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL
	virtual void OnCancel(void) {}
	virtual void OnOK(void) {}
    
public:
	BOOL UpdateData(BOOL bSaveAndValidate = TRUE);
    int GetDlgData(BASIC_INIT_DATA* pBasicSettings);
    int SetDlgData(BASIC_INIT_DATA* pBasicSettings);
    static int ComputeStatistics(BASIC_INIT_DATA* pBasicSettings, float* pBestSecureFraction = NULL, float* pAvgWhite = NULL);
    
    int GetGASettings(GA_STRATEGY* pStrategy);
	int SetGASettings(GA_STRATEGY* pStrategy);
    int EvolveDeployPattern(BOOL bBlackPattern);
    int LoadAndDeployByPattern(DWORD flags);
    
    static UINT RunGAS(LPVOID pParam);
	static void DeploySensors(BASIC_INIT_DATA* pBasicSettings);
	void LoadPopulationFromfile(CString file);
    
// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CKeyInfectTab)
	afx_msg void OnRecalculate();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
    afx_msg void OnBnClickedScriptinfectRun();
	afx_msg void OnDeploySensors();
    afx_msg void OnBnClickedGaScript();
    CString m_numGener;
    CString m_populSize;
    CString m_maxInstr;
    CString m_mutationProb;
    CString m_crossOverProb;
    CString m_numParties;
    CString m_nodeMemorySize;
    CString m_textProtocol;
    afx_msg void OnBnClickedExecuteFromtext();
    BOOL m_prunneResults;
    BOOL m_UseSfnc;
    CString m_sfncSlots;
    CString m_sfncSize;
    afx_msg void OnBnClickedRestartFromfile();
    afx_msg void OnBnClickedBlackPattern();
    CString m_cellsPerAxis;
    afx_msg void OnBnClickedWhitePattern();
    BOOL m_autoKeyDiscover;
    afx_msg void OnBnClickedBlackwhitePatternEvolution();
    afx_msg void OnBnClickedLoadBlackPattern();
    afx_msg void OnBnClickedLoadWhitePattern();
    int m_GAProtocolType;
    BOOL m_mutualRelative;
	CString	m_numDeployments;
    BOOL m_useWithFOE;
    BOOL m_groupProtocolSubFunctIdependent;
    BOOL m_addMoreDeploymentsFitnessTreshold;
    CString m_moreDeploymentsCounter;
    CString m_moreDeploymentsTreshold;
    afx_msg void OnBnClickedFindInsDependency();
    BOOL m_minimizeProtocolMessages;
    CString m_fitStableGeners;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_KEYINFECTTAB_H__DF69980F_42B8_4E38_8E00_98D5C9DE3170__INCLUDED_)
