#ifndef SSCONSTANTS_H
#define SSCONSTANTS_H

    // TAB FORMS
    #define ID_BASIC_TAB                         0x00    
    #define ID_KEYESTABLISH_TAB                  0x01
    #define ID_KEYINFECT_TAB                     0x02   
    #define ID_KEYPREDISTRIB_TAB                 0x03 
    #define ID_BSROUTE_TAB                       0x04
    #define ID_MESH_TAB                          0x05
    #define ID_NEIGHLEASH_TAB                    0x06  
	#define ID_REMOTECONTROL_TAB				 0x07
	#define ID_GRAPHIC_TAB						 0x08



    #define STR_BASIC_TAB                        "Basic init"    
    #define STR_KEYESTABLISH_TAB                 "Batch tests"
    #define STR_KEYINFECT_TAB                    "Key infection"
    #define STR_KEYPREDISTRIB_TAB                "Key predistrib."   
    #define STR_BSROUTE_TAB                      "BS routing"   
    #define STR_MESH_TAB                         "Mesh" 
    #define STR_NEIGHLEASH_TAB                   "Neigh. leashes"     
    #define STR_REMOTECONTROL_TAB                "Remote"   
	#define STR_GRAPHIC_TAB						 "Graphic"

	#define MAX_DEPLOYMENTS						 50

    #define APPROX_STEP                                 1000       // number of approximation points per 1 unit   
    #define MAX_POSSIBLE_COMPROMISSED_KEYS_PER_BLACK    500         // maximal number of keys, which one black node can possibly compromise (just technical limit) 
    #define MAX_SHARED_KEYS                         50        

    #define FLAG_SENSOR_WHITE                       0x00000001
    #define FLAG_SENSOR_BLACK                       0x00000002
    #define FLAG_SENSOR_BLACK_INACTIVENEIGH         0x00000004
    #define FLAG_SENSOR_NODE_INACTIVE               0x00000008
    #define FLAG_SENSOR_BASE_STATION                0x00000010
    #define FLAG_SENSOR_UNDEPLOYED                  0x00000020
    #define FLAG_SENSOR_NLEASH_COMPROMISED          0x00000040
//JK
	#define FLAG_SENSOR_GA_COMPROMISED				0x00000080

    
    #define FLAG_KEY_SECURE                       0x00000001
    #define FLAG_KEY_NEWLY_SECURE                 0x00000002  
    #define FLAG_PREDISTRIB_KEY_NOT_EXISTS        0x00000004    
    #define FLAG_KEY_SECURE_STARTUP               0x00000008   
    #define FLAG_KEY_COMPROMISED                  0x00010000   
    #define FLAG_KEY_MISSING                      0x00020000   


    #define FLAG_KEY_HELPMARK                     0x10000000   


//    #define MATLAB_BASE_PATH                      "E:\\xsvenda\\Matlab\\Sensor\\x"   
    #define MATLAB_BASE_PATH                      "C:\\Matlab7\\work\\Sensor\\x"   
//    #define MATLAB_BASE_PATH                      "D:\\Matlab7\\work\\Sensor\\x"   
//    #define MATLAB_BASE_PATH                      "C:\\!Matlab\\"   
//    #define MATLAB_BASE_PATH                      "J:\\!Matlab\\"   

    #define FLAG_USENEIGH_ALL                     0x00000001  
    #define FLAG_USENEIGH_ONLYXNEARST             0x00000002  
    #define FLAG_USENEIGH_DISTRIBUTION            0x00000004 
    #define FLAG_USENEIGH_AMPLIFICATION           0x00000008  

    #define FLAG_DISTRIB_SKIPDISTRIBMARKRANDOMLY        0x00000001        
    #define FLAG_DISTRIB_REMOVEMOSTCOMPRBLACK           0x00000002        
    #define FLAG_DISTRIB_REMOVEMOSTCOMPRBLACKWEIGHTED   0x00000004 
    #define FLAG_DISTRIB_MARKEQUALRANDOMLY              0x00000008       
    #define FLAG_DISTRIB_USEEGSCHEME                    0x00000010
    #define FLAG_DISTRIB_USEMULTIPATHMESSAGEDELIVERY    0x00000020                            
    #define FLAG_DISTRIB_BINDBLACKCOUNTRECEIVERATIO     0x00000040   
    #define FLAG_DISTRIB_BLACKINGRID                    0x00000080  
    #define FLAG_DISTRIB_USEFORWARDONIONENCRYPTION      0x00000100                         

    #define FLAG_KEYRING_IDSET                           0x00000000
    #define FLAG_KEYRING_BITMASK                         0x00000001

    #define FLAG_WHATSAVE_KEYSDISTRIBUTION              0x00000001  
    #define FLAG_WHATSAVE_SENSORPOSITION                0x00000002  
    #define FLAG_WHATSAVE_COMPROMISSEDBYSTATS           0x00000004
    #define FLAG_WHATSAVE_COMPRATIOALLMETHODS           0x00000008  
    #define FLAG_WHATSAVE_AMPLIFICATIONIMPACT           0x00000010    
    #define FLAG_WHATSAVE_COMPROMISSEDBYDISTANCE        0x00000020  
    #define FLAG_WHATSAVE_TRIANGLENEIGHPROPERTIES       0x00000040   
    #define FLAG_WHATSAVE_COMPROMISSEDBYNODEDENSITTY    0x00000080   
    #define FLAG_WHATSAVE_MMD                           0x00000100   
    #define FLAG_WHATSAVE_FOE                           0x00000200  
    #define FLAG_WHATSAVE_NEIGHBLEASH                   0x00000400  

    #define FLAG_RANDOMDISTRIB_BIDIRECTIONAL            0x00000001

    #define FLAG_METHOD_USEKEYINFECT                    0x00000001  
    #define FLAG_METHOD_USEMULTIPATHMESSAGEDELIVERY     0x00000002 
    #define FLAG_METHOD_USEFORWARDONIONENCRYPTION       0x00000004
    #define FLAG_METHOD_USEOPTIMALPOOLSIZE              0x00000008
    #define FLAG_METHOD_USENEIGHBLEASH                  0x00000010

    #define FLAG_BSPATH_NOTFOUND                        0x00000001
    #define FLAG_BSPATH_SECURE                          0x00000002
    #define FLAG_BSPATH_COMPROMISED                     0x00000004
    #define FLAG_BSPATH_NOTALLPATHSFOUND                0x00000008

    // CUSTOM WINDOWS MESSAGES
    #define WM_LOG_INSERTSTRING                     (WM_USER + 100)
    #define WM_RNG_UPDATESEED                       (WM_USER + 101)
	#define WM_THREAD_ENDED							(WM_USER + 102)

    #define LOG_STRING_MAX_SIZE                     50000


    // BASE STATION
    #define ACTIVEBS_NEAREST                        0x00   
    #define ACTIVEBS_RANDOM                         0x01
    
    // MULTIPATH MESSAGE DELIVER
    #define MMD_ROUTESTRAT_NEARESTTOBS              0x00
    #define MMD_ROUTESTRAT_NEARESTTOBS_GIVENDIST    0x01
	#define MMD_ROUTESTRAT_IGF                      0x02 

    // TYPE OF PERFORMED TEST
    #define FLAG_TESTTYPE_FIXEDTRANSMRANGE                  0x00000001 
    #define FLAG_TESTTYPE_VARIABLETRANSMRANGE               0x00000002 
    #define FLAG_TESTTYPE_VARIABLEBWCOUNTRATIO              0x00000004 
    #define FLAG_TESTTYPE_VARIABLEBLACKRECEIVESENSITIVITY   0x00000008 
    #define FLAG_TESTTYPE_VARIABLETOTALBASESTATIONCOUNT     0x00000010
    #define FLAG_TESTTYPE_VARIABLEACTIVEBASESTATIONCOUNT    0x00000020
    #define FLAG_TESTTYPE_VARIABLECOMPRNODESCOUNT           0x00000040
    #define FLAG_TESTTYPE_VARIABLEWHITENODESCOUNT           0x00000080
    #define FLAG_TESTTYPE_VARIABLEKEYPOOLSIZE               0x00000100
    #define FLAG_TESTTYPE_VARIABLEDROPCHECKPROB             0x00000200 
    #define FLAG_TESTTYPE_VARIABLECOMPRNODES                0x00000400   
    
	#define FLAG_TESTTYPE_EAPROTOCOLSEARCH                  0x00000800   
	#define FLAG_TESTTYPE_EABLACKPATTERNSEARCH              0x00001000   
	#define FLAG_TESTTYPE_EAWHITEPATTERNSEARCH              0x00002000   
	#define FLAG_TESTTYPE_EABLACKWHITEEVOLUTIONSEARCH       0x00004000   
	#define FLAG_TESTTYPE_EVOLVECIRCUIT                     0x00008000   
	#define FLAG_TESTTYPE_EVOLVENODEPICK                    0x00010000   
    
    
    // RESULTS DATA VALUES OFFSETS
    #define RESULTSOFFSET_COMPRATIOALLMETHODS               14
    #define RESULTSOFFSET_AMPLIFICATIONIMPACT               14
    #define RESULTSOFFSET_FOE                               10
    #define RESULTSOFFSET_NLEASH                            10


    // TEST QUEUE ACTIONS
    #define TESTQUEUE_ADD                                   1
    #define TESTQUEUE_RUN                                   2
    #define TESTQUEUE_CLEAR                                 3

    // FORWARD ONION ENCRYPTION FLAGS
    #define FLAG_FOE_MESSAGE_NOT_CAPTURED                   0x00000001 
    #define FLAG_FOE_MESSAGE_CAPTURED                       0x00000002 


    #define BITS_KEYS_MASK                                  32    

    // SENSITIVE OBJECT FLAGS
    #define FLAG_SENSITOBJECT_SIMPLEKEY                     0x00000001
    #define FLAG_SENSITOBJECT_COMPOSITEKEY                  0x00000002
    #define FLAG_SENSITOBJECT_KEY                           FLAG_SENSITOBJECT_SIMPLEKEY | FLAG_SENSITOBJECT_COMPOSITEKEY
    #define FLAG_SENSITOBJECT_MESSAGE                       0x00000004
    #define FLAG_SENSITOBJECT_CONTAINER                     0x00000008

    #define FLAG_SENSITOBJECTSEC_COMPROMISED                0x00000001
    #define FLAG_SENSITOBJECTSEC_INTERCEPTED                0x00000002
    
    // NEIGH LEASHES FLAGS  
    #define FLAG_TRANSMITCHECK_SENDERONLY                   0x00000001
    #define FLAG_TRANSMITCHECK_NEIGHPROB                    0x00000002
    #define FLAG_TRANSMITCHECK_ALLNEIGHS                    0x00000004
    
  
    // GENETIC ALGO STRATEGY
    #define GAS_KEYINFECT                                   1
    #define GAS_SECAMPLIF                                   2
  
    #define GAS_INSINACTIVE                                 0
    #define GAS_INSACTIVE                                   1

    #define GAS_NO_VALUE                                    0
    #define GAS_SIMPLEVALUE                                 2
    #define GAS_COMPOSITEVALUE                              3
    #define GAS_ENCRYPTEDVALUE                              4
    
    #define GAS_INSLENGTH                                   6
    #define GAS_ELEMENT_TYPE                                DWORD 

    #define NCR_ELEMENT_TYPE                                DWORD


    #define GAS_OFFSET_INSTYPE                              0
    #define GAS_OFFSET_INSTAT                               1
    #define GAS_OFFSET_NODE                                 2
    #define GAS_OFFSET_PARAM1                               3
    #define GAS_OFFSET_PARAM2                               4
    #define GAS_OFFSET_PARAM3                               5
    
    #define GAS_INS_NOP                                     0
    #define GAS_INS_RNG                                     1
    #define GAS_INS_COMBINE                                 2
    #define GAS_INS_REMOTECOMBINE                           3
    #define GAS_INS_SEND                                    4
    #define GAS_INS_ENCRYPT                                 5
    #define GAS_INS_DECRYPT                                 6
    #define GAS_INS_SWITCH                                  7
    #define GAS_INS_SUBFUNCTCALL                            8        
    // ACTUAL BIGGEST INSTRUCTION NUMBER
    #define GAS_INS_MAX                                     GAS_INS_SUBFUNCTCALL        

    #define GAS_FLAG_INSTYPE								0x00000001
    #define GAS_FLAG_INSTAT									0x00000002
    #define GAS_FLAG_NODE									0x00000004
    #define GAS_FLAG_PARAM1									0x00000008
    #define GAS_FLAG_PARAM2									0x00000010
    #define GAS_FLAG_PARAM3									0x00000020
	#define GAS_FLAG_ALL									GAS_FLAG_INSTYPE | GAS_FLAG_INSTAT | GAS_FLAG_NODE | GAS_FLAG_PARAM1 | GAS_FLAG_PARAM2 | GAS_FLAG_PARAM3

    #define FLAG_GAS_EAVESDROPPED                           0x00000001
    #define FLAG_GAS_COMPROMISED                            0x00000002

    #define GAS_SEPARATOR                                   "*************************************\r\n"
    #define GAS_HEADER_BEGIN                                "[HEADER_BEGIN]"
    #define GAS_HEADER_END                                  "[HEADER_END]"
    #define GAS_GENOM_BEGIN                                 "[GENOM_BEGIN]"
    #define GAS_GENOM_END                                   "[GENOM_END]"
    #define GAS_FITNESS_BEGIN                               "[FITNESS_BEGIN]"
    #define GAS_FITNESS_END                                 "[FITNESS_END]"
    #define GAS_SECURED_LINKS_BEGIN							"[SECURED_LINKS_BEGIN]"
    #define GAS_SECURED_LINKS_END							"[SECURED_LINKS_END]"
    #define GAS_MESSAGES_BEGIN								"[MESSAGES_BEGIN]"
    #define GAS_MESSAGES_END								"[MESSAGES_END]"
    
    #define GABP_SEPARATOR                                   "*************************************\r\n"
    #define GABP_HEADER_BEGIN                                "[GABP_HEADER_BEGIN]"
    #define GABP_HEADER_END                                  "[GABP_HEADER_END]"
    #define GABP_GENOM_BEGIN                                 "[GABP_GENOM_BEGIN]"
    #define GABP_GENOM_END                                   "[GABP_GENOM_END]"
    #define GABP_MAXMUTSTEP                                  INT_MAX / 100
    
    #define FLAG_PROTOCOL_NODESORIENTED                      0x00000001   
    #define FLAG_PROTOCOL_GROUPORIENTED                      0x00000002
    #define FLAG_PROTOCOL_MUTUALRELATIVEDISTANCE             0x00000004   
    #define FLAG_PROTOCOL_GROUP_INDEPENDENTEXECUTION         0x00000008  
    #define FLAG_PROTOCOL_GROUP_MINIMIZEMESSAGES             0x00000010
    #define FLAG_PROTOCOL_GROUP_MINIMIZEMESSAGES_INACTION    0x00000020   
    
    #define NODE_DIST_GRANULARITY                            100            // DO NOT EXTEND OVER 128 == 256/2
    
	#define     SCSAT_SOCKET_TIMEOUT            5
	#define     SCSAT_SOCKET_LONG_TIMEOUT       20
	#define     SCSAT_SOCKET_ENDSEQ             "@@"

	#define		S3_INSTANCES_LOGS_C			"C:\\s3_running_instances.ini"
	#define		S3_INSTANCES_LOGS_D			"D:\\s3_running_instances.ini"
	#define		S3_INSTANCES_LOGS_E			"E:\\s3_running_instances.ini"
	#define		S3_INSTANCES_TIME_DEAD		3600							// time in seconds after which the running instance is recognized as dead

	#define     PROXY_DISCONNECT            "disconnect"
	#define		PROXY_GETINSTANCES			"getInstances"
	#define     PROXY_GETTEXTFILECONTENT    "getTextFileContent"
	#define     PROXY_SETTEXTFILECONTENT    "setTextFileContent"
	#define     PROXY_GETBINARYTFILECONTENT "getBinFileContent"
	#define     PROXY_SETFILECONTENT        "setFileContent"
	#define		PROXY_COPYFILE				"copyFile"
	#define     PROXY_RUNAPPLICATION        "runApplication"
	#define     PROXY_SEPARATOR             "#"
	#define		PROXY_VALUE_SEPARATOR		"?"
	#define     ACTUAL_RESULTS_FILE         "act_result.txt"

    #define     HOST_ACTUAL                 "current process"

	#define		GAR_INS_SEND_M			0
	#define		GAR_INS_CATCH_M			1
	#define		GAR_INS_BROADCAST		2
	#define		GAR_INS_SEND_B			3
	#define		GAR_INS_STORE_M			4
	#define		GAR_INS_WAIT			5

#endif                                                       