// SavedCharsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SensorSim.h"
#include "SavedCharsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSavedCharsDlg dialog


CSavedCharsDlg::CSavedCharsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSavedCharsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSavedCharsDlg)
	m_saveComprByDensity = TRUE;
	m_saveAmplifImpact = TRUE;
	m_saveComprByDist = TRUE;
	m_saveComprByStat = TRUE;
	m_saveKeysDistrib = TRUE;
	m_saveSensorPos = TRUE;
	m_triangleNeighProp = FALSE;
    m_whatToSaveFlags = 0;
	m_basicComparTest = FALSE;
	//}}AFX_DATA_INIT
}


void CSavedCharsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSavedCharsDlg)
	DDX_Check(pDX, IDC_COMPR_BYNODEDENSITY, m_saveComprByDensity);
	DDX_Check(pDX, IDC_SAVE_AMPLIFIMPACT, m_saveAmplifImpact);
	DDX_Check(pDX, IDC_SAVE_COMPRBYDIST, m_saveComprByDist);
	DDX_Check(pDX, IDC_SAVE_COMPRBYSTAT, m_saveComprByStat);
	DDX_Check(pDX, IDC_SAVE_KEYSDISTRIB, m_saveKeysDistrib);
	DDX_Check(pDX, IDC_SAVE_SENSORPOSITION, m_saveSensorPos);
	DDX_Check(pDX, IDC_TRIANGLE_NEIGH_PROP, m_triangleNeighProp);
	DDX_Check(pDX, IDC_SAVE_BASICCOMPARTEST, m_basicComparTest);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSavedCharsDlg, CDialog)
	//{{AFX_MSG_MAP(CSavedCharsDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSavedCharsDlg message handlers

void CSavedCharsDlg::OnOK() 
{
    m_whatToSaveFlags = 0;
    GetDlgData(&m_whatToSaveFlags);
	
	CDialog::OnOK();
}


int CSavedCharsDlg::GetDlgData(DWORD* pWhatToSaveFlags) { 
    int status = STAT_OK;
    
    UpdateData(TRUE);

    if (m_saveAmplifImpact) *pWhatToSaveFlags |= FLAG_WHATSAVE_AMPLIFICATIONIMPACT;
    if (m_saveComprByDist) *pWhatToSaveFlags |= FLAG_WHATSAVE_COMPROMISSEDBYDISTANCE;
    if (m_saveComprByStat) *pWhatToSaveFlags |= FLAG_WHATSAVE_COMPROMISSEDBYSTATS;
    if (m_saveKeysDistrib) *pWhatToSaveFlags |= FLAG_WHATSAVE_KEYSDISTRIBUTION;
    if (m_saveSensorPos) *pWhatToSaveFlags |= FLAG_WHATSAVE_SENSORPOSITION;
    if (m_basicComparTest) *pWhatToSaveFlags |= FLAG_WHATSAVE_COMPRATIOALLMETHODS;
    if (m_saveComprByDensity) *pWhatToSaveFlags |= FLAG_WHATSAVE_COMPROMISSEDBYNODEDENSITTY;
    if (m_triangleNeighProp) *pWhatToSaveFlags |= FLAG_WHATSAVE_TRIANGLENEIGHPROPERTIES;

    return status;
}

int CSavedCharsDlg::SetDlgData(DWORD whatToSaveFlags) {
    int status = STAT_OK;
    
    m_saveAmplifImpact = (whatToSaveFlags & FLAG_WHATSAVE_AMPLIFICATIONIMPACT) ? TRUE : FALSE;
    m_saveComprByDist = (whatToSaveFlags & FLAG_WHATSAVE_COMPROMISSEDBYDISTANCE) ? TRUE : FALSE;
    m_saveComprByStat = (whatToSaveFlags & FLAG_WHATSAVE_COMPROMISSEDBYSTATS) ? TRUE : FALSE;
    
    m_saveKeysDistrib = (whatToSaveFlags & FLAG_WHATSAVE_KEYSDISTRIBUTION) ? TRUE : FALSE;
    m_saveSensorPos = (whatToSaveFlags & FLAG_WHATSAVE_SENSORPOSITION) ? TRUE : FALSE;
    m_basicComparTest = (whatToSaveFlags & FLAG_WHATSAVE_COMPRATIOALLMETHODS) ? TRUE : FALSE;
    m_saveComprByDensity = (whatToSaveFlags & FLAG_WHATSAVE_COMPROMISSEDBYNODEDENSITTY) ? TRUE : FALSE;
    m_triangleNeighProp = (whatToSaveFlags & FLAG_WHATSAVE_TRIANGLENEIGHPROPERTIES) ? TRUE : FALSE;

    UpdateData(FALSE);

    return status;
}    

BOOL CSavedCharsDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
    SetDlgData(m_whatToSaveFlags);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
