// SensorSimDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SensorSim.h"
#include "SensorSimCore.h"
#include "SensorSimDlg.h"
#include "VersionInfo.h"
#include "CommonFnc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CSensorSimDlg*  pSensorSimDlg = NULL;
extern CSensorSimCore*  pSensorSim;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSensorSimDlg dialog

CSensorSimDlg::CSensorSimDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSensorSimDlg::IDD, pParent)
    , m_hostPC(_T(""))
{
	//{{AFX_DATA_INIT(CSensorSimDlg)
	m_logs = _T("");
	m_keepLogBelow = TRUE;
	m_maxLogSize = _T("1000000");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	
	pSensorSimDlg = this;
}

CSensorSimDlg::~CSensorSimDlg() {

}

void CSensorSimDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CSensorSimDlg)
    DDX_Control(pDX, IDC_MAINTAB, m_mainTab);
    DDX_Text(pDX, IDC_LOGS, m_logs);
    DDX_Check(pDX, IDC_KEEP_LOG_BELOW, m_keepLogBelow);
    DDX_Text(pDX, IDC_MAX_LOG_SIZE, m_maxLogSize);
    //}}AFX_DATA_MAP
    DDX_CBString(pDX, IDC_COMBO_HOSTPC, m_hostPC);
}

BEGIN_MESSAGE_MAP(CSensorSimDlg, CDialog)
	//{{AFX_MSG_MAP(CSensorSimDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_NOTIFY(TCN_SELCHANGE, IDC_MAINTAB, OnSelchangeMaintab)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
    ON_EN_CHANGE(IDC_LOGS, &CSensorSimDlg::OnEnChangeLogs)
    ON_BN_CLICKED(IDC_STOP_CURRENT_OPERATIONS, &CSensorSimDlg::OnBnClickedStopCurrentOperations)
	ON_WM_WINDOWPOSCHANGING()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSensorSimDlg message handlers

BOOL CSensorSimDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

    // SET CAPTION WITH PATH INSIDE FOR EASIER MANAGEMENT OF MULTIPLE RUNNING INSTANCES 
    CString caption;
    CString newCaption;
    this->GetWindowText(caption.GetBuffer(MAX_PATH), MAX_PATH);
    caption.ReleaseBuffer();
    newCaption.Format("%s [%s]", caption, pSensorSim->m_basePath);
    this->SetWindowText(newCaption);

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	RECT rect;

	m_mainTab.InsertItem(ID_BASIC_TAB, STR_BASIC_TAB);
	m_mainTab.InsertItem(ID_KEYESTABLISH_TAB, STR_KEYESTABLISH_TAB);
	m_mainTab.InsertItem(ID_KEYINFECT_TAB, STR_KEYINFECT_TAB);
	m_mainTab.InsertItem(ID_KEYPREDISTRIB_TAB, STR_KEYPREDISTRIB_TAB);
	m_mainTab.InsertItem(ID_BSROUTE_TAB, STR_BSROUTE_TAB);
	m_mainTab.InsertItem(ID_MESH_TAB, STR_MESH_TAB);
	m_mainTab.InsertItem(ID_NEIGHLEASH_TAB, STR_NEIGHLEASH_TAB);
	m_mainTab.InsertItem(ID_REMOTECONTROL_TAB, STR_REMOTECONTROL_TAB);
	m_mainTab.InsertItem(ID_GRAPHIC_TAB, STR_GRAPHIC_TAB);

	m_mainTab.GetClientRect( &rect );
	m_mainTab.AdjustRect( FALSE, &rect );

	m_tabBasic.Create(IDD_BASIC_TAB, &m_mainTab);
	m_tabBasic.SetWindowPos( NULL, rect.left, rect.top, 0, 0, SWP_NOZORDER|SWP_NOSIZE );

	m_tabKeyEstablish.Create(IDD_KEYESTABLISH_TAB, &m_mainTab);
	m_tabKeyEstablish.SetWindowPos( NULL, rect.left, rect.top, 0, 0, SWP_NOZORDER|SWP_NOSIZE );

	m_tabKeyInfect.Create(IDD_KEYINFECT_TAB, &m_mainTab);
	m_tabKeyInfect.SetWindowPos( NULL, rect.left, rect.top, 0, 0, SWP_NOZORDER|SWP_NOSIZE );

	m_tabKeyPredistrib.Create(IDD_PREDISTRIB_TAB, &m_mainTab);
	m_tabKeyPredistrib.SetWindowPos( NULL, rect.left, rect.top, 0, 0, SWP_NOZORDER|SWP_NOSIZE );

	m_tabBSRoute.Create(IDD_BSROUTE_TAB, &m_mainTab);
	m_tabBSRoute.SetWindowPos( NULL, rect.left, rect.top, 0, 0, SWP_NOZORDER|SWP_NOSIZE );

	m_tabMesh.Create(IDD_MESH_TAB, &m_mainTab);
	m_tabMesh.SetWindowPos( NULL, rect.left, rect.top, 0, 0, SWP_NOZORDER|SWP_NOSIZE );

	m_tabNeighLeash.Create(IDD_NEIGHLEASHES_TAB, &m_mainTab);
	m_tabNeighLeash.SetWindowPos( NULL, rect.left, rect.top, 0, 0, SWP_NOZORDER|SWP_NOSIZE );

	m_tabRemoteControl.Create(IDD_REMOTE_CONTROL_TAB, &m_mainTab);
	m_tabRemoteControl.SetWindowPos( NULL, rect.left, rect.top, 0, 0, SWP_NOZORDER|SWP_NOSIZE );

	m_tabGraphic.Create(IDD_GRAPHIC_TAB, &m_mainTab);
	m_tabGraphic.SetWindowPos( NULL, rect.left, rect.top, 0, 0, SWP_NOZORDER|SWP_NOSIZE );
    
    ShowSpecificTab(ID_BASIC_TAB);

	// ALLOW WINDOW ACTIVATION IF NOT IN BACKGROUND
	if (pSensorSim->m_visible){
		ModifyStyleEx(WS_EX_NOACTIVATE, 0);
		SetActiveWindow();
	}

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSensorSimDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSensorSimDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSensorSimDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSensorSimDlg::HideAllTabs() {
	m_tabBasic.ShowWindow(SW_HIDE);
	m_tabKeyEstablish.ShowWindow(SW_HIDE);
	m_tabKeyInfect.ShowWindow(SW_HIDE);
    m_tabKeyPredistrib.ShowWindow(SW_HIDE);
    m_tabMesh.ShowWindow(SW_HIDE);
    m_tabBSRoute.ShowWindow(SW_HIDE);
    m_tabNeighLeash.ShowWindow(SW_HIDE);
	m_tabRemoteControl.ShowWindow(SW_HIDE);
	m_tabGraphic.ShowWindow(SW_HIDE);
}

void CSensorSimDlg::ShowBasicTab() {
	HideAllTabs();
	m_tabBasic.ShowWindow(SW_SHOWNORMAL);
}

void CSensorSimDlg::ShowKeyEstablishTab() {
	HideAllTabs();
	m_tabKeyEstablish.ShowWindow(SW_SHOWNORMAL);
}

void CSensorSimDlg::ShowKeyInfectTab() {
	HideAllTabs();
	m_tabKeyInfect.ShowWindow(SW_SHOWNORMAL);
}

void CSensorSimDlg::ShowKeyPredistribTab() {
	HideAllTabs();
	m_tabKeyPredistrib.ShowWindow(SW_SHOWNORMAL);
}

void CSensorSimDlg::ShowBSRouteTab() {
	HideAllTabs();
	m_tabBSRoute.ShowWindow(SW_SHOWNORMAL);
}
void ShowBSRouteTab();

void CSensorSimDlg::ShowMeshTab() {
	HideAllTabs();
	m_tabMesh.ShowWindow(SW_SHOWNORMAL);
}

void CSensorSimDlg::ShowNeighLeashTab() {
	HideAllTabs();
	m_tabNeighLeash.ShowWindow(SW_SHOWNORMAL);
}


void CSensorSimDlg::ShowRemoteControlTab() {
	HideAllTabs();
	m_tabRemoteControl.ShowWindow(SW_SHOWNORMAL);
}

void CSensorSimDlg::ShowGraphicTab() {
	HideAllTabs();
	m_tabGraphic.ShowWindow(SW_SHOWNORMAL);
}

void CSensorSimDlg::ShowSpecificTab(int tabID) {
	switch (tabID) {
		case ID_BASIC_TAB: {
	        m_mainTab.SetCurSel(ID_BASIC_TAB);
			ShowBasicTab();
			break;
		}
		case ID_KEYESTABLISH_TAB: {
	        m_mainTab.SetCurSel(ID_KEYESTABLISH_TAB);
			ShowKeyEstablishTab();
			break;
		}
		case ID_KEYINFECT_TAB: {
	        m_mainTab.SetCurSel(ID_KEYINFECT_TAB);
			ShowKeyInfectTab();
			break;
		}
		case ID_KEYPREDISTRIB_TAB: {
	        m_mainTab.SetCurSel(ID_KEYPREDISTRIB_TAB);
			ShowKeyPredistribTab();
			break;
		}
		case ID_BSROUTE_TAB: {
	        m_mainTab.SetCurSel(ID_BSROUTE_TAB);
			ShowBSRouteTab();
			break;
		}
		case ID_MESH_TAB: {
	        m_mainTab.SetCurSel(ID_MESH_TAB);
			ShowMeshTab();
			break;
		}
		case ID_NEIGHLEASH_TAB: {
	        m_mainTab.SetCurSel(ID_NEIGHLEASH_TAB);
			ShowNeighLeashTab();
			break;
		}
		case ID_REMOTECONTROL_TAB: {
	        m_mainTab.SetCurSel(ID_REMOTECONTROL_TAB);
			ShowRemoteControlTab();
			break;
		}
		case ID_GRAPHIC_TAB: {
			m_mainTab.SetCurSel(ID_GRAPHIC_TAB);
			ShowGraphicTab();
			break;
		}
		default: {
	        m_mainTab.SetCurSel(ID_BASIC_TAB);
			ShowBasicTab();
			break;
		}
	}	
}

void CSensorSimDlg::OnSelchangeMaintab(NMHDR* pNMHDR, LRESULT* pResult) 
{
    int sel = m_mainTab.GetCurSel();
    ShowSpecificTab(sel);
	
	*pResult = 0;
}

void CSensorSimDlg::Log_InsertString(CString message){
    UpdateData(TRUE);

	// ADD ENDING "\r\n" TO EXISTING LOG MESSAGE IF NOT ALREADY PRESENT
    if (m_logs.Right(2) != "\r\n") m_logs += "\r\n";
    m_logs += message;

	if (m_keepLogBelow) m_logs = m_logs.Right(atoi(m_maxLogSize));
	UpdateData(FALSE);
	Log_EnsureVisibleLastLine();
}
void CSensorSimDlg::Log_AppendString(CString message){
    UpdateData(TRUE);

    m_logs += message;

	if (m_keepLogBelow) m_logs = m_logs.Right(atoi(m_maxLogSize));
	UpdateData(FALSE);
	Log_EnsureVisibleLastLine();
}
void CSensorSimDlg::Log_InsertClearLine(){
    UpdateData(TRUE);
	
    m_logs += "\r\n";

    if (m_keepLogBelow) m_logs = m_logs.Right(atoi(m_maxLogSize));
	UpdateData(FALSE);
	Log_EnsureVisibleLastLine();
}
void CSensorSimDlg::Log_InsertSeparator(){
    UpdateData(TRUE);

    m_logs += "==================================================================\r\n"; 
	
    if (m_keepLogBelow) m_logs = m_logs.Right(atoi(m_maxLogSize));
	UpdateData(FALSE);
	Log_EnsureVisibleLastLine();
}

void CSensorSimDlg::Log_EnsureVisibleLastLine() {
    CEdit* pEdit;
    if ((pEdit = (CEdit*) GetDlgItem(IDC_LOGS)) != NULL) {
        pEdit->LineScroll(pEdit->GetLineCount());
/*
        int nFirstVisible = pEdit->GetFirstVisibleLine();

        // Scroll the edit control so that the first visible line
        // is the first line of text.
        if (nFirstVisible > 0)
        {
          pEdit->LineScroll(-nFirstVisible, 0);
        }
/**/
    }
/**/    
}


int CSensorSimDlg::GetBasicSettings(BASIC_INIT_DATA* pBasicSettings, BOOL bClearGA) {
    int status = STAT_OK;
    
    UpdateData(TRUE);
    
    pBasicSettings->clear(bClearGA);

    // GET SETTINGS FROM CBasicTab
    status = m_tabBasic.GetDlgData(pBasicSettings);

    // GET SETTINGS FROM m_tabKeyEstablish
    status = m_tabKeyEstablish.GetDlgData(pBasicSettings);

    // GET SETTINGS FROM m_tabKeyInfect
    status = m_tabKeyInfect.GetDlgData(pBasicSettings);

    // GET SETTINGS FROM m_tabKeyPredistrib
    status = m_tabKeyPredistrib.GetDlgData(pBasicSettings);
	
	// GET SETTINGS FROM m_tabBSRoute
    status = m_tabBSRoute.GetDlgData(pBasicSettings);
 
    // GET SETTINGS FROM m_tabNeighLeash
    status = m_tabNeighLeash.GetDlgData(pBasicSettings);

	// GET SETTINGS FROM m_tabMesh
    status = m_tabMesh.GetDlgData(pBasicSettings);
	
    // HEADER
    status = GetBasicSettingsHeader(pBasicSettings);
	
	m_hostPC.Trim();
	if (m_hostPC.GetLength() > 0) {pBasicSettings->remoteConfig.actualRemoteHost = m_hostPC;}
	else {pBasicSettings->remoteConfig.actualRemoteHost = HOST_ACTUAL;}
	
	return status;
}

int CSensorSimDlg::SetBasicSettings(BASIC_INIT_DATA* pBasicSettings) {
    int status = STAT_OK;
    
    // SET SETTINGS TO CBasicTab
    status = m_tabBasic.SetDlgData(pBasicSettings);

    // SET SETTINGS TO m_tabKeyEstablish
    status = m_tabKeyEstablish.SetDlgData(pBasicSettings);

    // SET SETTINGS TO m_tabKeyInfect
    status = m_tabKeyInfect.SetDlgData(pBasicSettings);

    // SET SETTINGS TO m_tabKeyPredistrib
    status = m_tabKeyPredistrib.SetDlgData(pBasicSettings);

    // SET SETTINGS TO m_tabBSRoute
    status = m_tabBSRoute.SetDlgData(pBasicSettings);
 
    // SET SETTINGS TO m_tabNeighLeash
    status = m_tabNeighLeash.SetDlgData(pBasicSettings);

	// SET SETTINGS TO m_tabRemoteControl
    status = m_tabRemoteControl.SetDlgData(pBasicSettings);

	// SET SETTINGS TO m_tabMesh
    status = m_tabMesh.SetDlgData(pBasicSettings);

    m_hostPC = pBasicSettings->remoteConfig.actualRemoteHost;

    UpdateData(FALSE);
    return status;
}

int CSensorSimDlg::GetBasicSettingsHeader(BASIC_INIT_DATA* pBasicSettings) {
    // PROGRAM VERSION + DATE
    CVersionInfo    ver;    
    ver.GetVersionInfo("SensorSim.exe");
    pBasicSettings->simulSWVersion = ver.m_strFixedProductVersion;
    char timeStr[MAX_PATH];_strdate(timeStr); 
    pBasicSettings->simulDate = timeStr;
    _strtime(timeStr);
    pBasicSettings->simulDate += " ";
    pBasicSettings->simulDate += timeStr;
    
    return STAT_OK;
}

void CSensorSimDlg::OnClose() 
{
    BOOL    close = FALSE;
		
	if (pSensorSim->m_pActualThread != NULL) {
        if (MessageBox("Running sub-thread with simulation detected. Do you really want to close application?", "Running simulations on background", MB_YESNO | MB_ICONWARNING) == IDYES) {
        	TerminateThread(pSensorSim->m_pActualThread->m_hThread, 0);
            close = TRUE;
        }
    }
    else {
        close = TRUE;
    }

    if (close) {
        pSensorSim->PostMessage(WM_CLOSE);
        CDialog::OnClose();		
    }
}

void CSensorSimDlg::OnEnChangeLogs()
{
    // TODO:  If this is a RICHEDIT control, the control will not
    // send this notification unless you override the CDialog::OnInitDialog()
    // function and call CRichEditCtrl().SetEventMask()
    // with the ENM_CHANGE flag ORed into the mask.

    // TODO:  Add your control notification handler code here
}

void CSensorSimDlg::OnBnClickedStopCurrentOperations()
{
    // SET SOFT FLAG FOR STOPPING CURRENT FLAG
    pSensorSim->m_stopThreadSoft = TRUE;
}

void CSensorSimDlg::OnWindowPosChanging(WINDOWPOS* lpwndpos)
{
	if(!pSensorSim->m_visible){
		lpwndpos->flags &= ~SWP_SHOWWINDOW;
        ShowWindow(SW_HIDE);
	}
	CDialog::OnWindowPosChanging(lpwndpos);
}

BOOL CSensorSimDlg::UpdateData(BOOL bSaveAndValidate){
	// WORKAROUND FOR EXECUTION IN BACKGROUND
	// ALLOW DATA UPDATE ONLY FROM MAIN THREAD
	if (AfxGetApp()->m_nThreadID == AfxGetThread()->m_nThreadID)
		return __super::UpdateData(bSaveAndValidate);
	else
		return FALSE;
}