// SensorSimDlg.h : header file
//

#if !defined(AFX_SENSORSIMDLG_H__092779F6_3178_4807_A935_2E20BA1CFFD6__INCLUDED_)
#define AFX_SENSORSIMDLG_H__092779F6_3178_4807_A935_2E20BA1CFFD6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "resource.h"
#include "BasicTab.h"
#include "KeyEstablishTab.h"
#include "KeyInfectTab.h"
#include "KeyPredistribTab.h"
#include "BSRouteTab.h"
#include "MeshTab.h"
#include "NeighLeashesTab.h"
#include "RemoteControlTab.h"
#include "GraphicTab.h"
#include "SensorEnv.h"
#include "socket.h"
#include "EACircuit.h"

/////////////////////////////////////////////////////////////////////////////
// CSensorSimDlg dialog

class CSensorSimDlg : public CDialog
{
// Construction
public:
	CSensorSimDlg(CWnd* pParent = NULL);	// standard constructor
    ~CSensorSimDlg();
	BOOL UpdateData(BOOL bSaveAndValidate = TRUE);
// Dialog Data
	//{{AFX_DATA(CSensorSimDlg)
	enum { IDD = IDD_SENSORSIM_DIALOG };
	CTabCtrl	m_mainTab;
	CString	    m_logs;
	BOOL	    m_keepLogBelow;
	CString	    m_maxLogSize;
	//}}AFX_DATA
        
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSensorSimDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL


// Implementation
public:
    //
    //  LOGGING FUNCTIONS
    //
    void Log_InsertString(CString message);
    void Log_AppendString(CString message);
    void Log_InsertClearLine();
    void Log_InsertSeparator();
    void Log_EnsureVisibleLastLine();
     
    int GetBasicSettings(BASIC_INIT_DATA* pBasicSettings, BOOL bClearGA = TRUE);
    int SetBasicSettings(BASIC_INIT_DATA* pBasicSettings);
    int GetBasicSettingsHeader(BASIC_INIT_DATA* pBasicSettings);
    
protected:

    void HideAllTabs();
    void ShowBasicTab();
    void ShowKeyEstablishTab();
    void ShowKeyInfectTab();
    void ShowKeyPredistribTab();
    void ShowBSRouteTab();
    void ShowMeshTab();
    void ShowNeighLeashTab();
	void ShowRemoteControlTab();
	void ShowGraphicTab();
	void ShowSpecificTab(int tabID);


public:
    CBasicTab           m_tabBasic;
    CKeyEstablishTab    m_tabKeyEstablish;
    CKeyInfectTab       m_tabKeyInfect;
    CKeyPredistribTab   m_tabKeyPredistrib;
    CBSRouteTab         m_tabBSRoute;
    CMeshTab            m_tabMesh;
    CNeighLeashesTab    m_tabNeighLeash;
	CRemoteControlTab	m_tabRemoteControl;
	CGraphicTab			m_tabGraphic;	
protected:    
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CSensorSimDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnSelchangeMaintab(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnClose();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
    afx_msg void OnEnChangeLogs();
public:
    afx_msg void OnBnClickedStopCurrentOperations();
public:
    CString m_hostPC;
	afx_msg void OnWindowPosChanging(WINDOWPOS* lpwndpos);
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SENSORSIMDLG_H__092779F6_3178_4807_A935_2E20BA1CFFD6__INCLUDED_)
