#ifndef GAS_Genome_CPP
#define GAS_Genome_CPP

#include "GAS_Genome.h"
#include "SSGlobals.h"

template <class T> const char *
GAS_Genome<T>::className() const {return "GAS_Genome";}
template <class T> int
GAS_Genome<T>::classID() const {return GAS_AID::GAS_Genome;}

template <class T> 
GAS_Genome<T>::
GAS_Genome(unsigned int length, GAGenome::Evaluator f, void * u) : GA1DArrayGenome<T>(length, f, u){
  stats.clear();
}

template <class T> 
GAS_Genome<T>::
GAS_Genome(const GAS_Genome<T>& orig) : 
GA1DArrayGenome<T>(orig.sz) {
  stats.clear();
  GAS_Genome<T>::copy(orig);
}

template <class T>
GAS_Genome<T>::~GAS_Genome(){

}

template <class T> GAGenome *
GAS_Genome<T>::clone(GAGenome::CloneMethod) const {
  return new GAS_Genome<T>(*this);
}

template <class T> void 
GAS_Genome<T>::copy(const GAGenome& orig){
  if(&orig == this) return;
  const GAS_Genome<T> * c = 
    DYN_CAST(const GAS_Genome<T>*, &orig);
  if(c) {
    GA1DArrayGenome<T>::copy(*c);
	stats = c->stats;
  }
}

#endif